package org.wffm.digicomi;

/*
 * D_GFrame.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

 
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;

import javax.swing.*;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

import org.wffm.gsmlviewer.*;

/**
  * fWR~pRt[NX
  * @version 1.0.0, 2001/01/30
  * @author Yosuke Sato
  */
public class D_GFrame extends GFrame {

	//
	//  [Jϐ
	//
	//=========================================================================
	private ResourceBundle rb = null;
	private final static String resourceName = "resources/Digicomi";
	
	private JMenuItem menuItem_Dic = null;
	private GElement dic = null;

	D_GSMLViewer _viewer = null;
		
	private ActionEventHandler actionEventHandler = new ActionEventHandler();

	private final static String softName = "Rs fWR~Configuration (Gassan)";
	private final static String version = "Version 1.0.0";

	//c[o[\iS
	private javax.swing.JToolBar ivjJToolBar1 = null;
	private javax.swing.JTextField ivjJTextField_Page = null;
	private javax.swing.JButton ivjJToolBarButton_Jump = null;
	private javax.swing.JButton ivjJToolBarButton_Last = null;
	private javax.swing.JButton ivjJToolBarButton_Next = null;
	private javax.swing.JButton ivjJToolBarButton_Prev = null;
	private javax.swing.JButton ivjJToolBarButton_Top = null;
	
	private ImageIcon dicIcon = new ImageIcon("resources/digicomi/dic.gif");
	private ImageIcon jumpIcon = new ImageIcon("resources/digicomi/jump.gif");
	private ImageIcon lastIcon = new ImageIcon("resources/digicomi/last.gif");
	private ImageIcon nextIcon = new ImageIcon("resources/digicomi/next.gif");
	private ImageIcon prevIcon = new ImageIcon("resources/digicomi/prev.gif");
	private ImageIcon topIcon = new ImageIcon("resources/digicomi/top.gif");
		
class ActionEventHandler implements ActionListener {
	public void actionPerformed(ActionEvent e) {
		if((e.getSource() == D_GFrame.this.getMenuItem_Dic())){
			showDicDialog();
		}
		
		if(_viewer.getState() == GSMLViewer.TEXT){
			if((e.getSource() == D_GFrame.this.getJToolBarButton_Next())){
				int counter = _viewer.getPageCounter();
				_viewer.operateCut(++counter);
			}
			else if((e.getSource() == D_GFrame.this.getJToolBarButton_Prev())){
				int counter = _viewer.getPageCounter();
				_viewer.operateCut(--counter);
			}
			else if((e.getSource() == D_GFrame.this.getJToolBarButton_Top())){
				_viewer.operateCut(1);
			}
			else if((e.getSource() == D_GFrame.this.getJToolBarButton_Last())){
				int last = _viewer.getPageMax();
				_viewer.operateCut(last);
			}
			else if((e.getSource() == D_GFrame.this.getJToolBarButton_Jump())){
				String page = D_GFrame.this.getJTextField_Page().getText();
				if(page != null){
					try{
						int pageNum = Integer.parseInt(page);
						_viewer.operateCut(pageNum);
					}catch(NumberFormatException ee){
					}
				}
			}
		}
	};
}
/**
 * RXgN^
 */
public D_GFrame(D_GSMLViewer _viewer) {
	super();
	this._viewer = _viewer;
}
private javax.swing.JTextField getJTextField_Page() {
	if (ivjJTextField_Page == null) {
		ivjJTextField_Page = new javax.swing.JTextField();
		ivjJTextField_Page.setName("JTextField_Page");
		ivjJTextField_Page.setPreferredSize(new java.awt.Dimension(50, 18));
		ivjJTextField_Page.setMaximumSize(new java.awt.Dimension(50, 18));
	}
	return ivjJTextField_Page;
}
protected javax.swing.JToolBar getJToolBar1() {
	if (ivjJToolBar1 == null) {
		ivjJToolBar1 = new javax.swing.JToolBar();
			ivjJToolBar1.setName("JToolBar1");
			getJToolBar1().add(getJToolBarButton_Top(), getJToolBarButton_Top().getName());
			getJToolBar1().add(getJToolBarButton_Prev(), getJToolBarButton_Prev().getName());
			getJToolBar1().add(getJToolBarButton_Next(), getJToolBarButton_Next().getName());
			getJToolBar1().add(getJToolBarButton_Last(), getJToolBarButton_Last().getName());
			ivjJToolBar1.addSeparator();
			getJToolBar1().add(getJTextField_Page(), getJTextField_Page().getName());
			getJToolBar1().add(getJToolBarButton_Jump(), getJToolBarButton_Jump().getName());
	}
	return ivjJToolBar1;
}
private javax.swing.JButton getJToolBarButton_Jump() {
	if (ivjJToolBarButton_Jump == null) {
		ivjJToolBarButton_Jump = new javax.swing.JButton();
		ivjJToolBarButton_Jump.setName("JToolBarButton_Jump");
		ivjJToolBarButton_Jump.setText("");
		ivjJToolBarButton_Jump.setMargin(new java.awt.Insets(0, 0, 0, 0));
		ivjJToolBarButton_Jump.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		ivjJToolBarButton_Jump.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
		ivjJToolBarButton_Jump.setToolTipText( rb.getString("toolbar.jump") );
		ivjJToolBarButton_Jump.setIcon(jumpIcon);
	}
	return ivjJToolBarButton_Jump;
}
private javax.swing.JButton getJToolBarButton_Last() {
	if (ivjJToolBarButton_Last == null) {
		ivjJToolBarButton_Last = new javax.swing.JButton();
		ivjJToolBarButton_Last.setName("JToolBarButton_Last");
		ivjJToolBarButton_Last.setText("");
		ivjJToolBarButton_Last.setMargin(new java.awt.Insets(0, 0, 0, 0));
		ivjJToolBarButton_Last.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		ivjJToolBarButton_Last.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
		ivjJToolBarButton_Last.setToolTipText( rb.getString("toolbar.last") );
		ivjJToolBarButton_Last.setIcon(lastIcon);
	}
	return ivjJToolBarButton_Last;
}
private javax.swing.JButton getJToolBarButton_Next() {
	if (ivjJToolBarButton_Next == null) {
		ivjJToolBarButton_Next = new javax.swing.JButton();
		ivjJToolBarButton_Next.setName("JToolBarButton_Next");
		ivjJToolBarButton_Next.setText("");
		ivjJToolBarButton_Next.setMargin(new java.awt.Insets(0, 0, 0, 0));
		ivjJToolBarButton_Next.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		ivjJToolBarButton_Next.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
		ivjJToolBarButton_Next.setToolTipText( rb.getString("toolbar.next") );
		ivjJToolBarButton_Next.setIcon(nextIcon);
	}
	return ivjJToolBarButton_Next;
}
private javax.swing.JButton getJToolBarButton_Prev() {
	if (ivjJToolBarButton_Prev == null) {
		ivjJToolBarButton_Prev = new javax.swing.JButton();
		ivjJToolBarButton_Prev.setName("JToolBarButton_Prev");
		ivjJToolBarButton_Prev.setText("");
		ivjJToolBarButton_Prev.setMargin(new java.awt.Insets(0, 0, 0, 0));
		ivjJToolBarButton_Prev.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		ivjJToolBarButton_Prev.setToolTipText( rb.getString("toolbar.prev") );
		ivjJToolBarButton_Prev.setIcon(prevIcon);
	}
	return ivjJToolBarButton_Prev;
}
private javax.swing.JButton getJToolBarButton_Top() {
	if (ivjJToolBarButton_Top == null) {
		ivjJToolBarButton_Top = new javax.swing.JButton();
		ivjJToolBarButton_Top.setName("JToolBarButton_Top");
		ivjJToolBarButton_Top.setText("");
		ivjJToolBarButton_Top.setMargin(new java.awt.Insets(0, 0, 0, 0));
		ivjJToolBarButton_Top.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		ivjJToolBarButton_Top.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
		ivjJToolBarButton_Top.setToolTipText( rb.getString("toolbar.top") );
		ivjJToolBarButton_Top.setIcon(topIcon);
	}
	return ivjJToolBarButton_Top;
}
private JMenuItem getMenuItem_Dic() {
	if (menuItem_Dic == null) {
		menuItem_Dic = new JMenuItem();
		menuItem_Dic.setName("menuItem_Dic");
		menuItem_Dic.setText( rb.getString("menuitem.dic") );
		menuItem_Dic.setIcon(dicIcon);
	}
	return menuItem_Dic;
}
public String getSoftName(){
	return softName;
}
public String getVersion(){
	return version;
}
/**
  * 
  * @param	env		
  * @param	size	TCY
  */
public void init(GElement env,Dimension size){
	super.init(env,size);
	rb = ResourceBundle.getBundle(resourceName);
	
	getMenu_Other().add(new JSeparator());
	getMenu_Other().add(getMenuItem_Dic());
	
	getMenuItem_Dic().setEnabled(false);

	//Cxg
	getMenuItem_Dic().addActionListener(actionEventHandler);
	
	getJToolBarButton_Jump().addActionListener(actionEventHandler);
	getJToolBarButton_Last().addActionListener(actionEventHandler);
	getJToolBarButton_Next().addActionListener(actionEventHandler);
	getJToolBarButton_Prev().addActionListener(actionEventHandler);
	getJToolBarButton_Top().addActionListener(actionEventHandler);

	//c[o[̃TCYvX
	//setSize((int)size.getWidth(),(int)size.getHeight()+50+25);
	setSize((int)size.getWidth()+35,(int)size.getHeight()+50);
}
/**
  * ݒ
  * @param	dic		
  */
public void setDic(GElement dic){
	if(dic == null){
		getMenuItem_Dic().setEnabled(false);
	}
	else{
		this.dic = dic;
		getMenuItem_Dic().setEnabled(true);
	}
}
private void showDicDialog(){
	//_CAO\
	if(dic != null){
		DicDialog dialog = new DicDialog();
		String data = "";
		
		GElement item;
		GElementList list = dic.getChildElements();
		for( list.first(),item = list.item() ; item != null ; list.next(),item = list.item() ){
			if(item.getName().equals("word")){
				data = data + "\n" + item.getAttributeValue("name") + " : " + "\n";
				GElement item2;
				GElementList list2 = item.getChildElements();
				for( list2.first(),item2 = list2.item() ; item2 != null ; list2.next(),item2 = list2.item() ){
					if(item2.getName().equals("text")){
						data = data + item2.getValue() + "\n";
					}
				}
			}
		}
		
		dialog.getJTextArea().setText(data);
		dialog.setTitle( rb.getString("dicdialog.title") );
		dialog.setVisible(true);
	}
}
}
