package org.wffm.digicomi;

/*
 * D_GSMLViewer.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * GStageView(fWR~p)
  * @version 1.0.0, 2001/01/29
  * @author Yosuke Sato
  */
public class D_GSMLViewer extends org.wffm.gsmlviewer.GSMLViewer {
	private int pageMax = 0;
	private int pageCounter = 0;
	private String title = "";
/**
 * RXgN^
 */
public D_GSMLViewer() {
	super();
}
/**
  * ݉c
  * @param	env	
  */
public void construct(GElement _env) {
	super.construct(_env);

	//c[o[zu
	//((D_GFrame)getGFrame()).getContentPane().add("North",((D_GFrame)getGFrame()).getJToolBar1());
	((D_GFrame)getGFrame()).getJToolBar1().setPreferredSize(new java.awt.Dimension(25, 236));
	((D_GFrame)getGFrame()).getContentPane().add("East",((D_GFrame)getGFrame()).getJToolBar1());
	((D_GFrame)getGFrame()).getJToolBar1().setOrientation(javax.swing.SwingConstants.VERTICAL);
	((D_GFrame)getGFrame()).getJToolBar1().setFloatable(false);
}
protected int getPageCounter(){
	return pageCounter;
}
protected int getPageMax(){
	return pageMax;
}
/**
  * w
  * @param	_scene	V[
  */
public void instruct(GElement _scene) {

	//y[WJE^
	pageCounter = 0;
	
	//őy[W擾
	pageMax = pageCounter(_scene);
	
	if(_scene != null){
		//Zbg
		GElementList list = _scene.getChildElements();
		list.first();
		list.search("dic");
		((D_GFrame)getGFrame()).setDic(list.item());
	}
	else{
		//e|C[W
		((D_ImagePane)getImagePane()).initImage();
	}

	//^Cg擾
	if(_scene != null){
		title = new String(getGFrame().getSoftTitle() + " - " + _scene.getAttributeValue("name") + " - ");
	}
	
	//EJCJ
	((D_ImagePane)getImagePane()).setRightOpen(true);
	
	if(_scene != null){
		String style = _scene.getAttributeValue("style");
		if(style != null){
			if(style.equals("left")){
				((D_ImagePane)getImagePane()).setRightOpen(false);
			}
		}
	}
	
	super.instruct(_scene);
}
protected void operateCut(int index){
	if( 0 < index && index < pageCounter){
		//߂
		initPane();
		
		((D_ImagePane)getImagePane()).setReverse(true);
		searchCut(index);
		getGFrame().setTitle( title + " ( " +pageCounter+ " / " +pageMax+" )" );
		
		operateCut();
	}
	else if(pageCounter <= index && index <= pageMax){
		//i
		initPane();
		
		searchCut(index);
		getGFrame().setTitle( title + " ( " +pageCounter+ " / " +pageMax+" )" );

		operateCut();
	}
}
protected void operateOtherCut(GElement element){
	if( element.getName().equals("marker") ){
		((D_ImagePane)getImagePane()).setMarker(element);
	}
}
protected void operateOtherScene(GElement other){
}
protected void operateScene(){
	if(getCursorScene() != null){
		for(GElement element = getCursorScene().item(); element != null; getCursorScene().next(),element = getCursorScene().item()){
			if( element.getName().equals("cut") ){
				//JbgJ[\
				setCursorCut(element.getChildElements());
				getCursorCut().first();

				//y[WZbg
				pageCounter++;
				getGFrame().setTitle( title + " ( " +pageCounter+ " / " +pageMax+" )" );
				
				operateCut();
				
				return;
			}
			else{
				operateOtherScene(element);
			}
		}
	}
	if(getDirector() != null){
		setState(NONE);
		getDirector().notifySceneEnd();
	}

}
private int pageCounter(GElement scene){
	int ret = 0;

	if(scene != null){
		GElementList list = scene.getChildElements();
		
		for(GElement element = list.item(); element != null; list.next(),element = list.item()){
			if(element.getName().equals("cut")){
				ret++;
			}
		}
	}
	
	return ret;
}
private void searchCut(int index){
	GElementList list = getCursorScene();

	if(list != null){
		//y[WJE^
		pageCounter = 0;
		
		list.first();
		for(GElement element = list.item(); element != null; list.next(),element = list.item()){
			if(element.getName().equals("cut")){
				pageCounter++;
				if(index == pageCounter){
					//JbgJ[\
					setCursorCut(element.getChildElements());
					getCursorCut().first();
					break;
				}
			}
		}
	}
}
}
