package org.wffm.digicomi;

/*
 * ImageDialog.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Image;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.image.BufferedImage;

import javax.swing.ImageIcon;
import javax.swing.SwingUtilities;

import org.wffm.gassan.model.scenario.GElement;

import org.wffm.gsmlviewer.pane.ImageCreaterFactory;
import org.wffm.gassan.view.image.ImageCreater;

/**
 * g勾
 * @version 1.0.0, 2001/01/30
 * @author Yosuke Sato
 */
public class ImageDialog extends javax.swing.JDialog {
	private javax.swing.JPanel ivjJDialogContentPane = null;
	private javax.swing.JLabel ivjJLabel = null;
	private javax.swing.JScrollPane ivjJScrollPane = null;
	int xx = 0;
	int yy = 0;

	public static final int rate = 2;
	public static final Dimension defaultSize = new Dimension(200,200);
/**
 * RXgN^[
 */
public ImageDialog() {
	super();
	initialize();
}
private Image createImage(Image image){
	int width = image.getWidth(this);
	int height = image.getHeight(this);
	BufferedImage ret = new BufferedImage(width*rate,height*rate,BufferedImage.TYPE_INT_RGB);
		
	Graphics g = ret.createGraphics();
	g.drawImage(image,0,0,width*rate,height*rate,this);
		
	return ret;
}
/**
 * JDialogContentPane ̃vpeB[l߂܂B
 * @return javax.swing.JPanel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JPanel getJDialogContentPane() {
	if (ivjJDialogContentPane == null) {
		try {
			ivjJDialogContentPane = new javax.swing.JPanel();
			ivjJDialogContentPane.setName("JDialogContentPane");
			ivjJDialogContentPane.setLayout(new java.awt.BorderLayout());
			getJDialogContentPane().add(getJScrollPane(), "Center");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJDialogContentPane;
}
/**
 * JLabel1 ̃vpeB[l߂܂B
 * @return javax.swing.JLabel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JLabel getJLabel() {
	if (ivjJLabel == null) {
		try {
			ivjJLabel = new javax.swing.JLabel();
			ivjJLabel.setName("JLabel");
			ivjJLabel.setText(" ");
			ivjJLabel.setBounds(0, 0, 73, 34);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel;
}
/**
 * JScrollPane1 ̃vpeB[l߂܂B
 * @return javax.swing.JScrollPane
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JScrollPane getJScrollPane() {
	if (ivjJScrollPane == null) {
		try {
			ivjJScrollPane = new javax.swing.JScrollPane();
			ivjJScrollPane.setName("JScrollPane");
			getJScrollPane().setViewportView(getJLabel());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane;
}
/**
 * p[cO throw 邽тɌĂяo܂B
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Lb`ĂȂOWo͂ɏo͂ɂ́A̍sRg܂ */
	// System.out.println("--------- Lb`ĂȂO ---------");
	// exception.printStackTrace(System.out);
}
/**
 * NX܂B
 */
/* x : ̃\bh͍Đ܂B */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("ImageDialog");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(426, 240);
		setContentPane(getJDialogContentPane());
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
public void show(GElement zoom,Image image,int x,int y){

	Image drawImage = null;
	if(zoom != null){
		ImageCreater creater = null;
		try{
			creater = ImageCreaterFactory.createImageLoader(zoom);
			drawImage = creater.getImage();
		}catch(Exception e){}
	}
	
	if(drawImage == null){
		drawImage = createImage(image);
	}
	ImageIcon icon = new ImageIcon(drawImage);
	
	getJLabel().setIcon(icon);
	getJLabel().setSize(drawImage.getWidth(this),drawImage.getHeight(this));
	
	//\ʒuZbg
	xx = x * rate;
	yy = y * rate;
	xx = xx - (int)defaultSize.getWidth() / 2;
	yy = yy - (int)defaultSize.getHeight() / 2;
	
	SwingUtilities.invokeLater(new Runnable() {
		public void run() {
			getJScrollPane().getHorizontalScrollBar().setValue(xx);
		}
	});
	SwingUtilities.invokeLater(new Runnable() {
		public void run() {
			getJScrollPane().getVerticalScrollBar().setValue(yy);
		}
	});
		
	setSize(defaultSize);
	setVisible(true);
}
}
