package jp.gr.java_conf.wffm.gassan.data;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;

/**
 *  Copyright (c) 1999 щΎR,Yousuke Satou All Rights Reserved.
 *  1999/11/30
 *  GADFileSystem:GADt@CI/ONX
 */
public class GADFileSystem {
private static void addZipEntry(File zipFile,Vector zipEntryFiles) {
	String[] file_list = zipFile.list();
	for(int i = 0;i < file_list.length ;i++){
		File file = new File(zipFile.getPath().replace('\\','/') + "/" + file_list[i]);
		
		if(file.isDirectory()){
			ZipEntry ze = new ZipEntry( file.getPath().replace('\\', '/') +"/");
			zipEntryFiles.addElement(ze);
			addZipEntry(file,zipEntryFiles);
		}
		else{
			ZipEntry ze = new ZipEntry( file.getPath().replace('\\', '/') );
			zipEntryFiles.addElement(ze);
		}
	}
}
/**
 * delDirectory\bh
 *   F dirName - fBNg
 *
 * w肳ꂽfBNgȉ̃t@CEfBNgSč폜B
 */
public static void delDirectory(String dirName) {
	File dir = new File(dirName);
	String[] file_list = dir.list();
	for(int i = 0 ; i < file_list.length ; i++){
		File file = new File(dir + "/" + file_list[i]);
		if(file.isDirectory())	delDirectory(file.getPath());
		file.delete();
	}
}
/**
 * readFile\bh
 *   F file - java.io.FileIuWFNg
 *			temp - WJfBNg
 *   ԒlF File
 */
public static File readFile(File file,String temp) {
	ZipInputStream  zi = null;
	ZipEntry        ze = null;
	
	//e|fBNg쐬
	File tempDir = new File(temp);
	tempDir.mkdirs();

	try{	
	
	InputStream  is = new FileInputStream(file);
	InputStream  bis = new BufferedInputStream(is);
	zi = new ZipInputStream(bis);
		
	while ((ze=zi.getNextEntry())!=null) {

		//  GgEt@C̎擾
		//-----------------------------------------------------------------
		String ename = ze.getName();
				
		//fBNg[̏ꍇKwƂɃfBNg쐬
		if(ze.isDirectory()){
						
			StringTokenizer st = new StringTokenizer(ze.getName(),"\\/");

			String path = temp;
			while(st.hasMoreTokens()){
				String s = st.nextToken();
				path = new String(path+"/"+s);
				File dir = new File(path);
				dir.mkdir();
			}
		}

		else{
			//  GgER[h̓ǂݍ
			//-----------------------------------------------------------------
			ByteArrayOutputStream  baos = new ByteArrayOutputStream();
			int  i;
			while((i=zi.read())!=-1) {
				baos.write(i);
			}
			byte[]  code = baos.toByteArray();

			FileOutputStream os = new FileOutputStream(temp +"/"+ ename);
			for(int j = 0; j < code.length;j++){
				os.write(code[j]);
			}
			os.close();
		}
		
	}

	}catch(Exception e){System.out.println(e);}
		
	//  ZipInputStreamN[Y
	//---------------------------------------------------------------------
	if (zi!=null) {
	   try {
		   zi.close();
	   } catch (Exception e) {return null;}
	}
	
	//GPDt@Č
	File unzipFile = new File(temp +"/projects");
	String projectName = null;	
	
	String[] file_list = unzipFile.list();

	for(int i = 0;i < file_list.length ; i++){
		File f = new File(temp +"/projects/"+file_list[i]);
		if(f.isDirectory()) projectName = file_list[i];
	}
	if(projectName == null)	return null;

	return new File(temp+"/projects/"+projectName,projectName+".gpd"); 	
}
/**
 * writeFile\bh
 *   F file - java.io.FileIuWFNg
 *          gadFileName - ۑGADt@C
 *          dirName - GADɈkfBNg
 */
public static void writeFile(String gadFileName,String dirName) {
	
	ZipOutputStream  zo = null;
		
	try{
		OutputStream  os = new FileOutputStream(gadFileName);
		OutputStream  bos = new BufferedOutputStream(os);
		zo = new ZipOutputStream(bos);
	
		File zipFile = new File(dirName);
		Vector zipEntryFiles = new Vector();
		
		//ZIPɃfBNg[܂܂ꍇ[fBNg[]/ƂB
		zipEntryFiles.addElement( new ZipEntry(zipFile.getPath().replace('\\','/') + "/") );
		addZipEntry(zipFile,zipEntryFiles);

		for(int i = 0;i < zipEntryFiles.size();i++){
			ZipEntry ze = (ZipEntry)zipEntryFiles.elementAt(i);
			zo.putNextEntry( ze );

			if(!ze.isDirectory()){
				//f[^̏
				int streamSize;
				byte b[] = new byte[1024];
				RandomAccessFile clientFile = new RandomAccessFile(ze.getName(), "r");
				while ((streamSize = clientFile.read(b)) > 0) {
  					zo.write(b, 0, streamSize);
				}
			}
			
			zo.closeEntry();
		}
				
		//  ZipInputStreamN[Y
		//---------------------------------------------------------------------
		if (zo!=null) {
		   try {
			   zo.close();
	 	  } catch (Exception e) {System.out.println(e);}
		}
	}
	catch(Exception e){}
	return;
}
}
