package org.wffm.gassan.model;

/*
 * ConsoleViewer.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.io.InputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Vector;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * R\[ŃTvView
  * @version 1.2.0, 2001/03/31
  * @author Yosuke Sato
  */
public class ConsoleViewer implements GStage {
	//
	//  ֘A
	//
	//=========================================================================
	private GDirector _director = null;
	private GElement _scene = null;
/**
 * RXgN^
 */
public ConsoleViewer() {
}
/**
  * ݉c
  * @param	env	
  */
public void construct(GElement env) {
	start();
}
/**
  * o҂擾
  * @return	o
  */
public GDirector getDirector() {
	return _director;
}
/**
  * V[擾
  * @return	V[
  */
public GElement getScene() {
	return _scene;
}
/**
  * w
  * @param	scene	V[
  */
public void instruct(GElement _scene) {
	this._scene = _scene;
	
	if(_scene != null){
		System.out.println("V[ : " + _scene.getAttributeValue("name") );
		GElementList list = _scene.getChildElements();
		list.first();
		for(GElement element = list.item(); element != null; list.next(),element = list.item()){
			if( element.getName().equals("cut") ){ operateCut(element);}
		}

		if(_director != null){
			//Z[u
			_director.savePerform(0);
			_director.notifySceneEnd();
		}
	}
	else	System.out.println("{I");
}
private void operateAudio(GElement audio){
	System.out.println("***************  Audio  ***************");
	System.out.println("C[ : "+ audio.getAttributeValue("layer"));
	System.out.println("R}h : "+ audio.getAttributeValue("command"));
	System.out.println("t@C : "+ audio.getAttributeValue("file"));
	System.out.println("******************************************");
}
private void operateCut(GElement cut){
	if(cut != null){
		String operate = null;
		
		GElementList list = cut.getChildElements();
		list.first();
		for(GElement element = list.item(); element != null; list.next(),element = list.item()){
			if( element.getName().equals("imagelist") ){ operateImagelist(element); }
			else if( element.getName().equals("text") ){ operateText(element); }
			else if( element.getName().equals("audio") ){ operateAudio(element); }
			else if( element.getName().equals("plugin") ){ operatePlugin(element); }
			else if( element.getName().equals("selection") ){
				operate = operateSelection(element);
				if(_director != null){
					_director.operation(operate);
				}
			}
		}
	}
}
private void operateImagelist(GElement imagelist){
	System.out.println("*************** C[WXg ***************");
	System.out.println("GtFNg : " + imagelist.getAttributeValue("effect") );
	
	GElementList list = imagelist.getChildElements();
	list.first();
	
	for(GElement element = list.item(); element != null; list.next(),element = list.item()){
		if(element.getName().equals("image")){
			System.out.println("***************  C[W  ***************");
			System.out.println("t@C : "+ element.getAttributeValue("file"));
			System.out.println("\ʒu : "+ element.getAttributeValue("position"));
			System.out.println("******************************************");
		}
	}

	System.out.println("**************************************************");
}
private void operatePlugin(GElement plugin){
	System.out.println("***************  vOC  ***************");
	System.out.println("vOC : "+ plugin.getAttributeValue("name"));

	GElementList list = plugin.getChildElements();
	list.first();
	
	for(GElement element = list.item(); element != null; list.next(),element = list.item()){
		if( element.getName().equals("param") ){
			System.out.println("p[^ : " + element.getAttributeValue("name") );
			System.out.println("l : " + element.getAttributeValue("value") );
		}
	}
		
	System.out.println("******************************************");
}
private String operateSelection(GElement selection){
	String ret = null;

	Vector operations = new Vector();
	
	GElementList list = selection.getChildElements();
	list.first();

	int listCounter = 0;
	for(GElement element = list.item(); element != null; list.next(),element = list.item()){
		if(element.getName().equals("alternative")){
			System.out.println(listCounter+" : "+element.getValue());
			operations.add(element.getAttributeValue("operation"));
			listCounter++;
		}
	}

	Integer integer = new Integer(0);
	int num = -1;
	InputStream in = System.in;
	BufferedReader d = new BufferedReader(new InputStreamReader(in));
	System.out.println("IIĉ");
	while(true){
		try{
			integer = new Integer(d.readLine());
		}
		catch(NumberFormatException e){
			System.out.println("̂ݓ͂Ă");
			integer = new Integer(-1);
		}
		catch(Exception e){
			System.out.println("\ȂO̔F" + e.getMessage());
		}
		num = integer.intValue();
		
		if( num < 0 || num >= listCounter ){
			System.out.println("ȃL[͂łBē͂Ă");
		}
		else break;
	}

	ret = (String)operations.elementAt(num);
	
	return ret;
}
private void operateText(GElement text){
	System.out.println(" : "+ text.getValue());
	try{
		InputStream in = System.in;
		BufferedReader d = new BufferedReader(new InputStreamReader(in));
		//System.out.println("EnterL[ĉ");
		String s = d.readLine();
	}
	catch(Exception e){}
}
/**
  * 
  */
public void reaction() {
}
/**
  * o҂ݒ
  * @param	director	o
  */
public void setDirector(GDirector _director) {
	this._director = _director;
}
private void start(){
	int ret = -1;
	Integer integer = new Integer(0);
		
	System.out.println("************************************");
	System.out.println(" RR\[Viewer Ver1.3");
	System.out.println("              Copyright WFFM 2001");
	System.out.println("              All Rights Reserved.");
	System.out.println("************************************");
	System.out.println(" 1 : ŏ");
	System.out.println(" 2 : ");
		
	InputStream in = System.in;
	BufferedReader d = new BufferedReader(new InputStreamReader(in));
	System.out.println("R}hIĉ");
	
	while(true){
		try{
			integer = new Integer(d.readLine());
		}
		catch(NumberFormatException e){
			System.out.println("̂ݓ͂Ă");
			integer = new Integer(-1);
		}
		catch(Exception e){
			System.out.println("\ȂO̔F" + e.getMessage());
		}
		ret = integer.intValue();
		if((ret <= 0) || (ret > 2)){
			System.out.println("ȃL[͂łBē͂Ă");
		}
		else break;
	}
	if(_director != null){
		if(ret == 1)	_director.startPerform();
		if(ret == 2)	_director.startPerform(0);
	}
}
}
