package org.wffm.gassan.model.io;

/*
 * GSML1_0to1_1.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.MalformedURLException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;
import org.wffm.gassan.model.scenario.GElementSerializer;

/**
  * GSML Version1.01.1֕ϊNX
  *
  * @version 1.1.0, 2001/01/29
  * @author Yosuke Sato
  */
public class GSML1_0to1_1 extends GSMLConverter {
	//
	//@W
	//
	//=========================================================================
	private Document _doc = null;
	
	//
	//@
	//
	//=========================================================================
	public final static String documentClassName = "org.apache.xerces.dom.DocumentImpl";
/**
  * RXgN^
  * @param	_GSMLInputStream	GSMLInputStream
  */
public GSML1_0to1_1(GSMLInputStream _GSMLInputStream) {
	super(_GSMLInputStream);
	
	try{
		//DocumentIuWFNg̐
		_doc = (Document)Class.forName( documentClassName ).newInstance();
	}catch(Exception e){
		System.err.println("Can not create Document.");
		_doc = null;
	}
}
private static final void addNode(Document doc,Element root,String strName,int iAge)
		{
				Element node=doc.createElement("HITO");
				Element item=doc.createElement("NAMAE");
				item.appendChild(doc.createTextNode(strName));
				node.appendChild(item);
				item=doc.createElement("NENREI");
				item.appendChild(doc.createTextNode(""+iAge));
				node.appendChild(item);
				item=doc.createElement("SINTYO");
				item.appendChild(doc.createTextNode("175"));
				node.appendChild(item);
				root.appendChild(node);
		}
private String convertCondition(GElement condition){
	String ret = "";

	if( condition.hasChildElements() ){
		GElementList list1 = condition.getChildElements();
		GElement item1;

		int counter = 0;
		
		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			if( item1.getName().equals("flagCondition") ){
				String name = item1.getAttributeValue("name");
				String flag = item1.getAttributeValue("switch");
				
				//u
				//1.0܂ł͕ϐɃXy[XĂ
				name = name.replace(' ','_');
				
				if(counter > 0){
					ret = ret + " and ";
				}	
				if(flag.equals("on")){
					ret = ret + name + " = " + "true";
				}
				else{
					ret = ret + name + " = " + "false";
				}
				counter++;
			}
		}
	}
	
	return ret;
}
private String convertConditions(GElement conditions){
	String ret = "";

	if( conditions.hasChildElements() ){
		GElementList list1 = conditions.getChildElements();
		GElement item1;

		int counter = 0;
		
		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			if( item1.getName().equals("condition") ){
				String condition = "( " + convertCondition(item1) + " ) ";
				if(counter > 0){
					ret = ret + " or ";
				}
				ret = ret + condition;	
				counter++;
			}
		}
	}

	return ret;
}
private void convertCut(Element scene,GElement cut,String backgroundFile){
	
	GElementList list = cut.getChildElements();
	
	/*** Lϊ ***/
	Element chara = null;
	
	list.first();
	list.search("chara");
	GElement element = list.item();

	if(element != null){
		Element imagelist = _doc.createElement("imagelist");
		Element image = null;
		
		Element effect = _doc.createElement("effect");
		effect.setAttribute("name", "org.wffm.gassan.view.effect.OverLay" );
		imagelist.appendChild(effect);
		
		//wiǉ
		if(backgroundFile != null){
			image = _doc.createElement("image");
			image.setAttribute("file", backgroundFile );
			image.setAttribute("position", "left");
			imagelist.appendChild(image);
		}
		
		//image = doc.createElement("image");
		//image.setAttribute("file", element.getAttributeValue("file") );
		//image.setAttribute("position", element.getAttributeValue("position"));
		//imagelist.appendChild(image);
			
		while( element != null ){
			image = _doc.createElement("image");
			image.setAttribute("file", element.getAttributeValue("file") );
			image.setAttribute("position", element.getAttributeValue("position"));
			imagelist.appendChild(image);
		
			list.next();
			list.search("chara");
			element = list.item();
		}
		scene.appendChild(imagelist);
	}
	/*********************/
	
	GElement item = null;
	for( list.first(),item = list.item() ; item != null ; list.next(),item = list.item() ){
		if( item.getName().equals("text") ){
			if(item.getAttributeValue("audioFile") != null){
				Element audio = _doc.createElement("audio");

				audio.setAttribute("layer", "voice" );
				audio.setAttribute("command", "play" );
				audio.setAttribute("file", item.getAttributeValue("audioFile") );

				scene.appendChild(audio);
			}
			Element text = _doc.createElement("text");

			text.appendChild(_doc.createTextNode( item.getValue() ));
			
			scene.appendChild(text);
		}
	}
}
private String convertDataOperation(GElement dataOperation){
	String ret = "";

	if( dataOperation.hasChildElements() ){
		GElementList list1 = dataOperation.getChildElements();
		GElement item1;

		int counter = 0;
		
		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			if( item1.getName().equals("flagOperation") ){
				String name = item1.getAttributeValue("name");
				String flag = item1.getAttributeValue("switch");

				//u
				name = name.replace(' ','_');
				
				if(counter > 0){
					ret = ret + " , ";
				}	
				if(flag.equals("on")){
					ret = ret + name + " := " + "true";
				}
				else{
					ret = ret + name + " := " + "false";
				}
				counter++;
			}
		}
	}
	
	return ret;
}
private Element createAlternative(GElement alternative){
	Element ret = null;

	if(alternative.hasChildElements()){
		ret = _doc.createElement("alternative");
		
		GElementList list1 = alternative.getChildElements();
		GElement item1;

		String operation = "";
		String text = "";
		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			//String operation = null;
			//String text = null;
			
			if( item1.getName().equals("dataOperation") ){
				operation = convertDataOperation(item1);
			}
			else if( item1.getName().equals("text") ){
				text = item1.getValue();
			}
		}
		ret.setAttribute("operation", operation );
		ret.appendChild(_doc.createTextNode(text));
	}	
		
	return ret;
}
private Element createAlternativeList(GElement alternativeList){
	Element ret = null;

	if(alternativeList.hasChildElements()){
		ret = _doc.createElement("selection");
		
		GElementList list1 = alternativeList.getChildElements();
		GElement item1;

		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			if( item1.getName().equals("alternative") ){
				Element element = createAlternative(item1);
				ret.appendChild(element);
			}
		}
	}	
	
	return ret;
}
private Element createBackground(GElement background){
	Element ret = null;

	ret = _doc.createElement("imagelist");

	Element effect = _doc.createElement("effect");
	
	String oldEffectName = background.getAttributeValue("effect");

	//pbP[Wϊ
	String newEffecName = replacePackage(oldEffectName);
	
	effect.setAttribute("name", newEffecName );
	ret.appendChild(effect);
		
	Element image = _doc.createElement("image");
	image.setAttribute("file", background.getAttributeValue("file") );
	image.setAttribute("position","left");

	ret.appendChild(image);

	return ret;
}
private Element createBGM(GElement bgm){
	Element ret = null;

	ret = _doc.createElement("audio");

	ret.setAttribute("layer", "bgm" );
	ret.setAttribute("command", "loop" );
	ret.setAttribute("file", bgm.getAttributeValue("file") );
	
	return ret;
}
private Element createBranch(GElement branch){
	Element ret = null;
	
	if(branch.hasChildElements()){
		ret = _doc.createElement("if");
		String condition = convertConditions(branch);
		ret.setAttribute("condition", condition );

		GElementList list1 = branch.getChildElements();
		GElement item1;

		list1.first();
		list1.search("scenarioLink");
		item1 = list1.item();
		if( item1 != null){
			ret.setAttribute("gsmlFile", item1.getAttributeValue("file") );
		}
	}
	
	return ret;
}
private Element createGSML(GElement gsml){
	Element ret = null;

	ret = _doc.createElement("gsml");
	ret.setAttribute("version", "1.1" );
		
	//GSML1.0 -> GSML1.1ϊR[h
	if(gsml.hasChildElements()){
		GElementList list1 = gsml.getChildElements();
		GElement item1;
		
		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			if( item1.getName().equals("dataOperation") ){
				Element data = _doc.createElement("data");
				String operation = convertDataOperation(item1);
				data.setAttribute("operation",operation);
				ret.appendChild(data);
			}
			else if( item1.getName().equals("scene") ){
				Element scene = createScene(item1);
				ret.appendChild(scene);
			}
			else if( item1.getName().equals("branch") ){
				Element branch = createBranch(item1);
				ret.appendChild(branch);
			}
			else if( item1.getName().equals("loop") ){
				Element loop = createLoop(item1);
				ret.appendChild(loop);
			}
			else if( item1.getName().equals("end") ){
				//ϊ̕Kv
				Node node = _doc.importNode(item1.getNode(),true);
				ret.appendChild(node);
			}
		}
	}
	
	return ret;
}
private Element createLoop(GElement loop){
	Element ret = null;
	
	if(loop.hasChildElements()){
		ret = _doc.createElement("loop");
		String condition = convertConditions(loop);
		ret.setAttribute("condition", condition );

		GElementList list1 = loop.getChildElements();
		GElement item1;

		list1.first();
		list1.search("scenarioLink");
		item1 = list1.item();
		if( item1 != null){
			ret.setAttribute("gsmlFile", item1.getAttributeValue("file") );
		}
	}
	
	return ret;
}
private Element createPlugin(GElement plugin){
	Element ret = null;

	ret = _doc.createElement("plugin");
	String oldName = plugin.getAttributeValue("name");

	//pbP[Wϊ
	String newName = plugin.getAttributeValue(oldName);

	ret.setAttribute("name",newName);
	
	return ret;
}
private Element createScene(GElement scene){
	Element ret = null;
			
	if(scene.hasChildElements()){
		ret = _doc.createElement("scene");
		Element cut = _doc.createElement("cut");
		
		GElementList list1 = scene.getChildElements();
		GElement item1;
		
		//Oϊ
		list1.first();
		list1.search("sceneName");
		item1 = list1.item();
		if( item1 != null){
			ret.setAttribute("name", item1.getValue() );
		}

		//wiϊ
		String backgroundFile = null;
		
		list1.first();
		list1.search("backGround");
		item1 = list1.item();
		if(item1 != null){
			Element element = createBackground(item1);
			cut.appendChild(element);
			backgroundFile = getBackground(item1);
		}

		//yϊ
		list1.first();
		list1.search("bgm");
		item1 = list1.item();
		if( item1 != null){
			Element element = createBGM(item1);
			cut.appendChild(element);
		}
		
		for( list1.first(),item1 = list1.item() ; item1 != null ; list1.next(),item1 = list1.item() ){
			if( item1.getName().equals("cut") ){
				convertCut(cut,item1,backgroundFile);
			}
			else if( item1.getName().equals("plugin") ){
				//ϊ̕Kv
				Node node = _doc.importNode(item1.getNode(),true);
				cut.appendChild(node);
			}
			else if( item1.getName().equals("alternativeList") ){
				Element element = createAlternativeList(item1);
				cut.appendChild(element);
			}
		}

		ret.appendChild(cut);
	}

	return ret;
}
private String getBackground(GElement background){
	return background.getAttributeValue("file");
}
/**
  * eXgp\bh
  */
public static void main(String[] argv){
	try{
		
		File file = new File(argv[0]);
		GElement element = GElement.create(file.toURL());
		
		GSMLThrowInputStream gtis = new GSMLThrowInputStream( element );
		GSMLConverter converter = new GSML1_0to1_1( gtis );
		GElement convert = converter.read();
		
		//Wo͂֏o
		//OutputFormat format=new OutputFormat(convert.getCurrentDocument());
		//format.setDoctype(null,"gsml.dtd");
		//format.setEncoding("Shift_JIS");
		//GElementSerializer.serialize(System.out,format,convert);
		
		GElementSerializer.serialize(System.out,convert,"Shift_JIS");
	}
	catch( ArrayIndexOutOfBoundsException e){
		System.err.println("Usage: java GSML1_0to1_1 filename");
	}
	catch( IOException e ){
		System.err.println(argv[0] + "not Found");
	}
	catch( SAXException e){
		System.err.println("SAXError");
		System.err.println(e);
	}
	catch( GSMLIOException e){
		System.err.println("GSMLIOError");
	}
}
/**
  * GSMLǂݍ
  * @return	ϊꂽGSML
  */
public GElement read() throws GSMLIOException{
	GElement ret = null;

	ret = super.read();
	
	Element element = null;
	
	try{
		//System.out.println("GSML1.0 -> GSML1.1֕ϊ");
		
		//͑GSML1.0,1.0.1
		String version = ret.getAttributeValue("version");

		if(version != null){
			if(version.equals("1.0") || version.equals("1.0.1")){
				element = createGSML(ret);
			}
			else{
				throw new GSMLIOException("version error.");
			}
		}
		else{
			//---sȂVer3.0̃TvɃo[Ww肪oOɑΉR[h
			GElementList list = ret.getChildElements();
			list.first();
			GElement loop = list.item();
			if(loop != null && loop.getName().equals("loop")){
		
				element = createGSML(ret);
			}
			else{
				throw new GSMLIOException("version error.");
			}
			//---
		}

		//Ԓl:GSML1.0 -> GSML1.1֕ϊꂽGSML
		
		//Document֒ǉ
		_doc.appendChild(element);
		
		ret = new GElement(element,ret.getBaseURL(),_doc);

		//GElementSerializer.serialize(System.out,ret,"Shift_JIS");
	}
	catch(Exception e){
		throw new GSMLIOException("stream error");
	}
	
	
	return ret;
}
public static String replacePackage(String value){
	String ret = value;
	
	//pbP[Wϊ
	if(ret  != null){
		String replacePackageName = "jp.gr.java_conf.wffm.gassan.sample.";
		if( ret.length() > replacePackageName.length() ){
			String packageName = ret.substring(0, replacePackageName.length() );
			if(packageName.equals( replacePackageName )){
				String planeret = ret.substring(replacePackageName.length(),ret.length());
				ret = "org.wffm.gassan.sample." + planeret;
			}
		}
		
		replacePackageName = "jp.gr.java_conf.wffm.gassan.view.effect.";
		if( ret.length() > replacePackageName.length() ){
			String packageName = ret.substring(0, replacePackageName.length() );
			if(packageName.equals( replacePackageName )){
				String planeret = ret.substring(replacePackageName.length(),ret.length());
				ret = "org.wffm.gassan.view.effect." + planeret;
			}
		}

		replacePackageName = "jp.gr.java_conf.wffm.gassan.view.plugin.";
		if( ret.length() > replacePackageName.length() ){
			String packageName = ret.substring(0, replacePackageName.length() );
			if(packageName.equals( replacePackageName )){
				String planeret = ret.substring(replacePackageName.length(),ret.length());
				ret = "org.wffm.gassan.view.plugin." + planeret;
			}
		}
	}

	return ret;
}
}
