package org.wffm.gassan.model.scenario;

/*
 * GElement.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.io.File; 
import java.io.Serializable;
import java.io.IOException;
import java.net.URL;
import java.net.MalformedURLException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Attr;
import org.w3c.dom.Text;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import org.apache.xerces.parsers.DOMParser;

/**
  * \vf(NodeNX̃bp[)
  * ̃NX̎ȓ
  * 1. Node̋󔒋L̏
  * 2. eՂȃAgr[gւ̃ANZX
  * 3. eՂȃ\[Xւ̃ANZX
  *
  * @version 1.1.3, 2001/02/01
  * @author Yosuke Sato
  */
public class GElement implements Serializable{
	//
	//  W
	//
	//=========================================================================
	private Node _node = null;

	//
	//  
	//
	//=========================================================================
	private URL baseURL = null;					//̍\vf݂΃pX
	private Document currentDocument = null;	//ݓǂݍ񂾃hLg
/**
  * RXgN^
  * @param	node			m[h
  * @param	url				\[X𐶐ׂ̊ƂȂURL
  * @param	currentDocument	݂Document
  */
public GElement(Node node,URL url,Document currentDocument){
	setNode(node);
	setBaseURL(url);
	setCurrentDocument(currentDocument);
}
/**
  * GElement𐶐
  * @param	fileName	GSMLURL
  * @return	ꂽ؍\(GElement)
  * @exception	SAXException
  * @exception	SAXParseException
  * @exception  IOException
  */
public static GElement create(URL url) throws SAXException,SAXParseException,IOException {
	GElement ret = null;		

	if(url != null){

		String uriString = url.toString();
		InputSource uri = new InputSource( uriString );
		Element root = null;
			
		DOMParser parser = new DOMParser();
		parser.parse( uri );
		Document currentDocument = parser.getDocument();
		root = (Element)currentDocument.getDocumentElement();
									
		/****************** JAXP **********************
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance ();
		DocumentBuilder db = dbf.newDocumentBuilder ();
		Document currentDocument = db.parse(uri);
		root = (Element)currentDocument.getDocumentElement();
		**********************************************/
				
		//baseURL쐬
		int fileSeparatorIndex = uriString.lastIndexOf( "/" );
		String baseURLName = uriString.substring( 0, fileSeparatorIndex + 1 );
		URL baseURL = null;
		try {
	 		baseURL = new URL( baseURLName );
		} catch ( MalformedURLException ex ) {
			System.err.println("can not create baseURL.");
			baseURL = null;
		}
		
		//GSML
		ret = new GElement((Node)root,baseURL,currentDocument);
	}
	return ret;
}
/**
  * ̍\vfƎw肳ꂽ\vfr
  * @param	element	r\vf
  * @return	r
  */
public boolean equals(GElement element){
	boolean ret = false;

	if( getBaseURL().equals(element.getBaseURL()) ){
		if( getNode().equals(element.getNode()) ){
			ret = true;
		}
	}
	return ret;
}
/**
  * W擾
  * @return	̃}bv(NamedNodeMap)
  */
public NamedNodeMap getAttributes(){
		return _node.getAttributes();
}
/**
  * 擾
  * @param	name	̖O
  * @return	
  * ) ݂ȂꍇԒlnull
  */
public String getAttributeValue(String name){
	String ret = null;
	
	if(_node != null){
		NamedNodeMap map = _node.getAttributes();
		Attr attr = (Attr)map.getNamedItem(name);
		if(attr != null){
			ret = attr.getValue();
		}
		if(ret != null && ret.length() == 0){
			ret = null;	//AttrgꍇɂđꍇC0̕Ԃ̂nullԂlɂĂ
		}
	}
	
	return ret;
}
/**
  * baseURL擾
  * @return	\[Ẍׂ̊URL
  */
public URL getBaseURL(){
	return baseURL;
}
/**
  * \vfXg擾
  * @return	\vfXg(GElementListNX)
  */
public GElementList getChildElements(){
	GElementList ret = new GElementList(this);
	ret.first();
	return ret;
}
/**
  * ݂Document擾
  * @return	݂Document
  */
public Document getCurrentDocument(){
	return currentDocument;
}
/**
  * O擾
  * @return	\vf̖O
  */
public String getName(){
	return _node.getNodeName();
}
/**
  * m[h擾
  * @return	m[h
  */
public Node getNode(){
	return _node;
}
/**
  * e擾
  * @return	\vf̓e
  */
public String getValue(){
	String ret = null;

	NodeList nodes = _node.getChildNodes();

	if(nodes != null){
		StringBuffer buffer = new StringBuffer();
		int size = nodes.getLength();
		for (int i = 0;i < size;i++) {
			Node node = nodes.item(i);
			if (node.getNodeType() == Node.TEXT_NODE) {
				Text text = (Text)node;
				buffer.append(text.getData());
			}
		}
		ret = new String(buffer);
	}
		
	return ret;
}
/**
  * q̍\vfĂ邩
  * @return	q̍\vf݂ꍇtrue,ȊOfalse
  */
public boolean hasChildElements(){
	boolean ret = false;
	
	//qm[hɈłElementΎqĂD
	for(Node childNode = _node.getFirstChild();childNode != null;childNode = childNode.getNextSibling()){
		if(childNode.getNodeType() == Node.ELEMENT_NODE){
			ret = true;
			break;
		}
	}
	
	return ret;
}
/**
  * eXgp\bh
  */
public static void main( String argv[] ){
	//GElement,GElementListeXgp\bh
	try{
		File file = new File(argv[0]);
		GElement element = GElement.create(file.toURL());
		if(element.hasChildElements()){
			GElementList list = element.getChildElements();
			GElement item1,item2;
			
			System.out.println("--- ANZXeXgJn ---");
			list.first();
			item1 = list.item();
			if(item1 != null){
				System.out.println( item1.getName() );
				System.out.println( item1.getBaseURL() );
			}
			list.next();
			item1 = list.item();
			if(item1 != null){
				System.out.println( item1.getName() );
				System.out.println( item1.getBaseURL() );
			}

			System.out.println("--- reXgJn ---");
			list.first();
			item1 = list.item();
			item2 = list.item();
			System.out.println( item1.equals(item2) );

			System.out.println("--- eXgJn ---");
			list.first();
			list.search("scene");
			item1 = list.item();
			if( item1 != null ){
				System.out.println( item1.getName() );
			}
			else{
				System.out.println("No hit");
			}
		}
	}
	catch( ArrayIndexOutOfBoundsException e){
		System.err.println("Usage: java GElement filename");
	}
	catch( IOException e ){
		System.err.println(argv[0] + "not Found");
	}
	catch( Exception e){
		System.err.println("Error....");
		System.err.println(e);
	}
}
/**
  * baseURLݒ
  * @param	baseURL	\[X𐶐ׂ̊ƂȂURL
  */
public void setBaseURL(URL baseURL){
	this.baseURL = baseURL;
}
/**
  * ݂Documentݒ
  * @param	currentDocument	݂Document
  */
public void setCurrentDocument(Document currentDocument){
	this.currentDocument = currentDocument;
}
/**
  * m[hݒ
  * @param	_node	m[h
  */
public void setNode(Node _node){
	this._node = _node;
}
}
