package org.wffm.gassan.model.translator;

/*
 * GPDTranslator.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.io.File;
import java.io.Serializable;
import java.net.URL;
import java.net.MalformedURLException;
import java.util.Hashtable;

import org.wffm.gassan.model.scenario.GElement;
import jp.gr.java_conf.wffm.gassan.data.*;

/**
  * GPD`̖|
  * @version 1.1.2, 2000/10/20
  * @author Yosuke Sato
  */
public class GPDTranslator implements GTranslator,Serializable {
	//
	//@
	//
	//=========================================================================
	private URL gpdURL = null;
	private URL baseURL = null;

	//
	//@
	//
	//=========================================================================
	private String cursorKey = null;
	
	//
	//@[Jϐ
	//
	//=========================================================================
	private Hashtable scripts = null;
	private String nextScriptKey = null;
	private SceneData scenedata = null;
	
	public final static String defaultStartKey = "START";
/**
 * RXgN^
 * @param	gpdURL GPDt@C݂URL
 */
public GPDTranslator(URL  gpdURL) {
	this.gpdURL = gpdURL;

	String URLString = gpdURL.toString();
	
	//baseURL
	int fileSeparatorIndex = URLString.lastIndexOf( "/" );
	String baseURLName = URLString.substring( 0, fileSeparatorIndex + 1 );
	try {
		this.baseURL = new URL( baseURLName );
	} catch ( MalformedURLException ex ) {
		ex.printStackTrace();
		this.baseURL = null;
	}
}
/**
  * J[\ŏ̗vfֈړ
  */
public void first() {
	File file = new File(gpdURL.getFile());
	scripts = SceneHashFileSystem.readFile(file);
	cursorKey = defaultStartKey;
}
/**
  * J[\̗vfֈړ
  */
public void next() {
	if(!scenedata.getIsJunction()){
		//V[̏ꍇ
		cursorKey = scenedata.getNextSceneFileName(0);
	}
	else{
		//Ȉꍇ
		cursorKey = nextScriptKey;
	}
}
/**
  * f[^
  * @param	operation	f[^
  */
public void operation(String operation) {
	nextScriptKey = operation;
}
/**
  * V[擾
  * @return	V[̖؍\(GElementNX)CInullԂD
  */
public GElement scene() {
	GElement ret = null;
		
	if(scripts != null && cursorKey != null){
		scenedata = (SceneData)scripts.get(cursorKey);
		if(scenedata != null){
			ret = GPDtoGSML.createScene(scenedata,cursorKey,baseURL);
		}
	}
	
	return ret;
}
}
