package org.wffm.gassan.model.translator;

/*
 * GSMLTranslator.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.io.*;
import java.net.URL;
import java.util.Stack;

import org.wffm.gassan.model.io.*;
import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * GSML`̖|
  * @version 1.1.2, 2000/10/20
  * @author Yosuke Sato
  */
public class GSMLTranslator implements GTranslator,Serializable{
	//
	//@
	//
	//=========================================================================
	private URL gsmlURL = null;
	
	//
	//@W
	//
	//=========================================================================
	private Stack _stack = null;
	private StatusManager _StatusManager = null;
	
	//
	//@
	//
	//=========================================================================
	private GElementList root = null;
/**
 * RXgN^
 * @param	gsmlURL GSMLt@C݂URL
 */
public GSMLTranslator(URL gsmlURL) {
	super();
	_stack = new Stack();
	_StatusManager = new StatusManager();
	this.gsmlURL = gsmlURL;
}
private GElement createGSML(URL url){
	GElement ret = null;

	try{
		//GElement
		GElement element = null;
		element = GElement.create(url);
		
		//o[WRg[
		String version = element.getAttributeValue("version");
		if(version != null){
			if(version.equals("1.0") || version.equals("1.0.1")){
			
				//͑GSML1.0,1.0.1̏ꍇ
				GSMLThrowInputStream gtis = new GSMLThrowInputStream( element );
				GSMLConverter converter = new GSML1_0to1_1( gtis );
			
				ret = converter.read();
			}
			else{
				//ȊO
				ret = element;
			}
		}
		else{
			//---sȂVer3.0̃TvɃo[Ww肪oOɑΉR[h
			//͑GSML1.0,1.0.1Ɖ
			GElementList list = element.getChildElements();
			list.first();
			GElement loop = list.item();
			if(loop != null && loop.getName().equals("loop")){
				System.err.println("x!!DTDᔽ : version");
				GSMLThrowInputStream gtis = new GSMLThrowInputStream( element );
				GSMLConverter converter = new GSML1_0to1_1( gtis );
				ret = converter.read();
			}
			else{
				//ȊO
				ret = element;
			}
			//---
		}
	}
	catch(org.xml.sax.SAXException se){
		System.err.println("GSML Parser Error...");
	}
	catch(java.io.IOException ie){
		System.err.println("GSML IO Error...");
	}
	catch(GSMLIOException e){
		System.err.println("GSML Stream Error...");
	}
	catch(Exception e){
		System.err.println("GSML Read Error...");
	}
	
	return ret;
}
private GElementList createScenarioLink(GElement link){
	GElementList ret = null;
	
	String file = link.getAttributeValue("gsmlFile");
	if(file != null){
		String gsmlURLName = link.getBaseURL().toString() + file;
		
		try {
	   		URL url = new URL( gsmlURLName );
	   		
			//ViI
			GElement element = createGSML(url);
			if(element.hasChildElements()){
				ret = element.getChildElements();
			}
		} catch ( Exception ex ) {
	 		System.out.println("can not create root");
	   		ret = null;
		}
	}
	return ret;
}
/**
  * J[\ŏ̗vfֈړ
  */
public void first(){

	//J[\
	root = null;

	//GSML
	GElement element = createGSML(gsmlURL);
	//J[\
	if(element != null){
		if(element.hasChildElements()){
			root = element.getChildElements();
			root.first();
			//J[\V[֐i߂
			operate();
		}
	}
}
/**
  * eXgp\bh
  */
public static void main(String[] argv){
	try{
		File file = new File(argv[0]);

		//GSMLTranslator
		GSMLTranslator aGSMLTranslator = new GSMLTranslator(file.toURL());

		aGSMLTranslator.first();
		GElement scene = aGSMLTranslator.scene();
		if(scene != null){
			System.out.println(scene.getAttributeValue("name"));
		}
		while(scene != null){
			aGSMLTranslator.next();
			scene = aGSMLTranslator.scene();
			if(scene != null){
				System.out.println(scene.getAttributeValue("name"));
			}
		}	
	}
	catch( ArrayIndexOutOfBoundsException e){
		System.err.println("Usage: java GSMLTranslator filename");
	}
	catch( IOException e ){
		System.err.println(argv[0] + "not Found");
	}
}
/**
  * J[\̗vfֈړ
  */
public void next(){
	if(root != null){
		root.next();
		//J[\V[֐i߂
		operate();
	}
	else{
		System.out.println("root is NULL.");
	}
}
private void operate(){
	 while(root != null) {
		GElement element = root.item();

		while(element != null){
			
			if(element.getName().equals("data")){
				operateData(element);
			}
			else if(element.getName().equals("if") || element.getName().equals("loop") ){
				
				GElementList list = operateIf(element);
				
				//script̐ɎsĂȂmF
				if(list != null){
					_stack.push(root);
					root = list;
					
					//root̃J[\
					root.first();
					element = root.item();
					
					continue;
				}
			}
			else if(element.getName().equals("scene")){
				return;
			}
			else if(element.getName().equals("end")){
				root = null;
				return;
			}
			root.next();
			element = root.item();
		}
		
		if(!_stack.empty()){
			root = (GElementList)_stack.pop();
			
			//[v̏ꍇ
			GElement loop = root.item();
			if(loop.getName().equals("loop")){
				GElementList list = operateIf(loop);
				//script̐ɎsĂȂmF
				if(list != null){
					_stack.push(root);
					root = list;
					
					//root̃J[\
					root.first();
					element = root.item();
					
					continue;
				}
			}
			
			//[g̃J[\i߂
			root.next();
		}
		else{
			//X^bNȂ΃ViII
			root = null;
			return;
		}
	}
}
private void operateData(GElement data){
	//ݒ
	_StatusManager.operation( data.getAttributeValue("operation") );
}
private GElementList operateIf(GElement ifElement){
	GElementList ret = null;
	
	//ɓK邩`FbN
	if( _StatusManager.condition( ifElement.getAttributeValue("condition") ) ){
		ret = createScenarioLink(ifElement);
	}

	return ret;
}
/**
  * f[^
  * @param	operation	f[^
  */
public void operation(String operation){
	//ݒ
	_StatusManager.operation( operation );
}
/**
  * V[擾
  * @return	V[̖؍\(GElementNX)CInullԂD
  */
public GElement scene(){
	GElement ret = null;
	
	if(root != null){
		ret = root.item();
	}

	return ret;
}
}
