package org.wffm.gassan.view.effect;

/*
 * ExchangeEffect.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Component;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.util.Map;

/**
  * C[WʏNX̊NX
  * @version 1.1.2, 2001/01/08
  * @author Yosuke Sato
  */
public abstract class ExchangeEffect{
	
	//
	//  
	//
	//=========================================================================
	private Map param = null;					//p[^
	private BufferedImage beforeImage = null;	//ʂÕC[W
	private BufferedImage afterImage = null;	//ʂ̃C[W
	private Dimension imageSize = null;			//C[W̃TCY
	private Component comp = null;

	public static final String packageName = "org.wffm.gassan.view.effect.";
/**
  * ExchangeEffectpNX𐶐
  * @param	className	ExchangeEffectpNX̖O
  * @return	ꂽExchangeEffect
  */
public static ExchangeEffect create(String className) {
	ExchangeEffect ret = null;
	
	try{
		ret = (ExchangeEffect)Class.forName(className).newInstance();
	}
	catch(Exception e){
		ret = null;
	}

	//pbP[W⊮@\
	if(ret == null){
		try{
			ret = (ExchangeEffect)Class.forName(packageName + className).newInstance();
		}
		catch(Exception e){
			System.err.println("Can not create effect : "+className);
			ret = null;
		}
	}
	
	return ret;
}
/**
  * ̃C[W擾
  * @return	̃C[W
  */
public BufferedImage getAfterImage(){
	return afterImage;
}
/**
  * ÕC[W擾
  * @return	ÕC[W
  */
public BufferedImage getBeforeImage(){
	return beforeImage;
}
/**
  * java.awt.Component擾
  * @return	java.awt.Component
  */
public java.awt.Component getComponent(){
	return comp;
}
/**
  * C[W̃TCY擾
  * @return	C[W̃TCY
  */
public Dimension getImageSize(){
	return imageSize;
}
/**
  * p[^擾
  * @return	p[^
  */
public Map getParam(){
	return param;
}
/**
  * ʏ
  */
public abstract void init() throws ExchangeEffectException;
/**
  * ʏJn
  */
public abstract void run();
/**
  * ̃C[Wݒ
  * @param	afterImage	̃C[W
  */
public void setAfterImage(BufferedImage afterImage){
	this.afterImage = afterImage;
}
/**
  * ÕC[Wݒ
  * @param	beforeImage	ÕC[W
  */
public void setBeforeImage(BufferedImage beforeImage){
	this.beforeImage = beforeImage;
}
/**
  * java.awt.Componentݒ
  * @param	comp	java.awt.Component
  */
public void setComponent(Component comp){
	this.comp = comp;
}
/**
  * C[W̃TCYݒ
  * @param	imageSize	C[W̃TCY
  */
public void setImageSize(Dimension imageSize){
	this.imageSize = imageSize;
}
/**
  * p[^ݒ
  * @param	param	p[^
  */
public void setParam(Map param){
	this.param = param;
}
/**
  * ^C}[
  * @param	i	~b
  */
protected void timer(int i) {
	try{
		Thread.sleep(i);
	}catch(InterruptedException e){}
}
}
