/* Public Domain Sources */

package org.wffm.gassan.view.filter;

import java.awt.Image;
import java.awt.Toolkit;

import java.awt.image.ImageProducer;
import java.awt.image.FilteredImageSource;

import org.wffm.gassan.view.image.ImageCreaterException;import java.util.List;/**
  * OCtB^[NX
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  * @author Yosuke Sato
  */
public class GrayFilter extends Filter {
public static Image filtering(Image i) {
	return Toolkit.getDefaultToolkit().createImage(
	  new FilteredImageSource(i.getSource(),new GrayFilter(true, 50))
	);
}        
  private boolean brighter;
  private int percent;
public GrayFilter(boolean b, int p) {
	super();
	brighter = b;
	percent = p;
	canFilterIndexColorModel = true;
}        
public int filterRGB(int x, int y, int rgb) {
	int gray = (int)((0.30 * ((rgb >> 16) & 0xff) + 0.59 * ((rgb >> 8) & 0xff) + 0.11 * (rgb & 0xff)) / 3);
	gray=((brighter)?(255 - ((255 - gray) * (100 - percent) / 100)):(gray * (100 - percent) / 100));
	if (gray < 0) gray = 0;
	if (gray > 255) gray = 255;
	return (rgb & 0xff000000) | (gray << 16) | (gray << 8) | (gray << 0);
}        
/**
 * RXgN^
 */
public GrayFilter() {
	brighter = true;
	percent = 50;
}/**
  * C[W擾
  * @return	C[W
  */
public Image getImage() throws ImageCreaterException{
	Image ret = null;

	try{
		Image sourceImage = getSource().getImage();
		ret = Toolkit.getDefaultToolkit().createImage( new FilteredImageSource(sourceImage.getSource(), this));
	}catch(Exception e){
		throw new ImageCreaterException();
	}
	return ret;
}}