/* Public Domain Sources */

package org.wffm.gassan.view.loader.bmp;

import java.io.IOException;


/**
  * BitmapFileHeader
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  */
public class BitmapFileHeader extends Object {

  private static final int bfTYPE='B'*256+'M';

  public static BitmapFileHeader load(WordableDataInputStream is) throws IOException,BMPException {
	if(is.readUnsignedByte()!='B'||is.readUnsignedByte()!='M')throw new BMPException("Data is not BMP data");
	int bfSize = is.readDWORD();
	int bfReserved1 = is.readWORD();
	int bfReserved2 = is.readWORD();
	int bfOffBits = is.readDWORD();
	return new BitmapFileHeader(bfSize,bfReserved1,bfReserved2,bfOffBits);
  }          

  private int bfSize;         // t@CTCY(DWORD)
  private int bfReserved1;    // \(WORD)
  private int bfReserved2;    // \(WORD)
  private int bfOffBits;      // sNZf[^܂ł̃oCgItZbg(DWORD)

  public BitmapFileHeader(int bfSize,int bfReserved1,int bfReserved2,int bfOffBits){
	super();
	this.bfSize=bfSize;
	this.bfReserved1=bfReserved1;
	this.bfReserved2=bfReserved2;
	this.bfOffBits=bfOffBits;
  }          

  public int getFileSize(){return bfSize;}          
  public int getOffsetByte(){return bfOffBits;}          

}