package org.wffm.gsmlviewer;

/*
 * GBootLoader.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ResourceBundle;

import org.wffm.gassan.model.App;
import org.wffm.gassan.model.GDirector;
import org.wffm.gassan.model.GDirectorImpl;
import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

import org.wffm.gsmlviewer.factory.ViewFactory;
import org.wffm.gsmlviewer.pane.TextPane;
import org.wffm.gsmlviewer.pane.ImagePane;
import org.wffm.gsmlviewer.pane.TextPaneController;

/**
  * Ru[g[_NX
  * @version 1.0.2, 2001/01/22
  * @author Yosuke Sato
  */
public class GBootLoader extends JFrame {
	private JButton ivjJButton_Start = null;
	private JButton ivjJButton_File = null;
	private JTextField ivjJTextField_File = null;
	private JLabel ivjJLabel_Scenario = null;
	private JLabel ivjJLabel_Logo = null;
	private JPanel ivjJFrameContentPane = null;
	private JPanel ivjJPanel_Button = null;
	private JPanel ivjJPanel_Main = null;
	
	IvjEventHandler ivjEventHandler = new IvjEventHandler();

	private ResourceBundle rb = null;
	private final static String resourceName = "resources/GBootLoader";
	
	public static final String defaultViewFactory = "org.wffm.gsmlviewer.factory.DialogTextFactory";
	public static final String logoFile = "resources/logo.gif";
	public static final String defaultIconFileName = "resources/icon.gif";
	
class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == GBootLoader.this.getJButton_File()) 
				connEtoC1(e);
			if (e.getSource() == GBootLoader.this.getJButton_Start()) 
				connEtoC2(e);
		};
	};
/**
 * RXgN^
 */
public GBootLoader() {
	super();
	initialize();
}
/**
 * connEtoC1:  (JButton_File.action.actionPerformed(java.awt.event.ActionEvent) --> GRuncher.pushFileButton()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* x : ̃\bh͍Đ܂B */
private void connEtoC1(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.pushFileButton();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (JButton_Start.action.actionPerformed(java.awt.event.ActionEvent) --> GRuncher.pushStartButton()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* x : ̃\bh͍Đ܂B */
private void connEtoC2(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.pushStartButton();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * JButton_View ̃vpeB[l߂܂B
 * @return javax.swing.JButton
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JButton getJButton_File() {
	if (ivjJButton_File == null) {
		try {
			ivjJButton_File = new javax.swing.JButton();
			ivjJButton_File.setName("JButton_File");
			ivjJButton_File.setText( rb.getString("button.file") );
			ivjJButton_File.setBounds(298, 39, 85, 25);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton_File;
}
/**
 * JButton_Start ̃vpeB[l߂܂B
 * @return javax.swing.JButton
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JButton getJButton_Start() {
	if (ivjJButton_Start == null) {
		try {
			ivjJButton_Start = new javax.swing.JButton();
			ivjJButton_Start.setName("JButton_Start");
			ivjJButton_Start.setText( rb.getString("button.start") );
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton_Start;
}
/**
 * JFrameContentPane ̃vpeB[l߂܂B
 * @return javax.swing.JPanel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(new java.awt.BorderLayout());
			getJFrameContentPane().add(getJPanel_Button(), "South");
			getJFrameContentPane().add(getJLabel_Logo(), "North");
			getJFrameContentPane().add(getJPanel_Main(), "Center");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * JLabel_Logo ̃vpeB[l߂܂B
 * @return javax.swing.JLabel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JLabel getJLabel_Logo() {
	if (ivjJLabel_Logo == null) {
		try {
			ivjJLabel_Logo = new javax.swing.JLabel();
			ivjJLabel_Logo.setName("JLabel_Logo");
			ivjJLabel_Logo.setPreferredSize(new java.awt.Dimension(390, 45));
			ivjJLabel_Logo.setText("");
			ivjJLabel_Logo.setMaximumSize(new java.awt.Dimension(390, 45));
			ivjJLabel_Logo.setMinimumSize(new java.awt.Dimension(390, 45));
			// user code begin {1}
			ImageIcon imageIcon = new ImageIcon(logoFile);
			ivjJLabel_Logo.setIcon(imageIcon);
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel_Logo;
}
/**
 * JLabel_Scenario ̃vpeB[l߂܂B
 * @return javax.swing.JLabel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JLabel getJLabel_Scenario() {
	if (ivjJLabel_Scenario == null) {
		try {
			ivjJLabel_Scenario = new javax.swing.JLabel();
			ivjJLabel_Scenario.setName("JLabel_Scenario");
			ivjJLabel_Scenario.setText( rb.getString("label.scenario") );
			ivjJLabel_Scenario.setBounds(7, 15, 203, 14);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel_Scenario;
}
/**
 * JPanel_Button ̃vpeB[l߂܂B
 * @return javax.swing.JPanel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JPanel getJPanel_Button() {
	if (ivjJPanel_Button == null) {
		try {
			ivjJPanel_Button = new javax.swing.JPanel();
			ivjJPanel_Button.setName("JPanel_Button");
			ivjJPanel_Button.setLayout(new java.awt.FlowLayout());
			getJPanel_Button().add(getJButton_Start(), getJButton_Start().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJPanel_Button;
}
/**
 * JPanel_Main ̃vpeB[l߂܂B
 * @return javax.swing.JPanel
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JPanel getJPanel_Main() {
	if (ivjJPanel_Main == null) {
		try {
			ivjJPanel_Main = new javax.swing.JPanel();
			ivjJPanel_Main.setName("JPanel_Main");
			ivjJPanel_Main.setBorder(new javax.swing.border.EtchedBorder());
			ivjJPanel_Main.setLayout(null);
			getJPanel_Main().add(getJLabel_Scenario(), getJLabel_Scenario().getName());
			getJPanel_Main().add(getJTextField_File(), getJTextField_File().getName());
			getJPanel_Main().add(getJButton_File(), getJButton_File().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJPanel_Main;
}
/**
 * JTextField_Scenario ̃vpeB[l߂܂B
 * @return javax.swing.JTextField
 */
/* x : ̃\bh͍Đ܂B */
private javax.swing.JTextField getJTextField_File() {
	if (ivjJTextField_File == null) {
		try {
			ivjJTextField_File = new javax.swing.JTextField();
			ivjJTextField_File.setName("JTextField_File");
			ivjJTextField_File.setBounds(7, 39, 284, 25);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJTextField_File;
}
private static ViewFactory getViewFactory(GElement env){
	ViewFactory ret = null;
	
	String className = null;
	
	if(env != null){
		GElementList list = env.getChildElements();
		GElement item = null;
		
		list.first();
		list.search("view");
		item = list.item();

		if(item != null){
			className = item.getAttributeValue("type");
		}
	}
	if(className != null){
		ret = ViewFactory.create(className);
	}
	if(ret == null){
		ret = ViewFactory.create(defaultViewFactory);
	}
	return ret;
}
/**
 * p[cO throw 邽тɌĂяo܂B
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Lb`ĂȂOWo͂ɏo͂ɂ́A̍sRg܂ */
	// System.out.println("--------- Lb`ĂȂO ---------");
	// exception.printStackTrace(System.out);
}
/**
 * ڑ̏
 * @exception java.lang.Exception OLq
 */
/* x : ̃\bh͍Đ܂B */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getJButton_File().addActionListener(ivjEventHandler);
	getJButton_Start().addActionListener(ivjEventHandler);
}
/**
 * NX܂B
 */
/* x : ̃\bh͍Đ܂B */
private void initialize() {
	try {
		// user code begin {1}
		rb = ResourceBundle.getBundle(resourceName);
		// user code end
		setName("GBootLoader");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setResizable(false);
		setSize(390, 164);
		setContentPane(getJFrameContentPane());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	setTitle( rb.getString("title") );
	
	//ACRݒ
	Image iconImage = null;
	ImageIcon imageIcon = new ImageIcon(defaultIconFileName);
	iconImage = imageIcon.getImage();
	setIconImage( iconImage );
	// user code end
}
/**
 * main֐
 * @param	args	R}hC(1:ViIt@C)
 * N) java -classpath .;lib/xml4j.jar scenario/index.geml
 */
public static void main(java.lang.String[] args) {
	//System.setErr(System.out);
	String fileName = "";
	if ( args.length > 0 ) {
		fileName = args[0];
	}

	if ( args.length != 0 ) {
		//Ru[g[_NViewJn
		if(!viewStarter(fileName)){
			System.out.println("can not read : " + fileName );
			System.exit(0);
		}
	}
	else{
		//Ru[g[_N
		GBootLoader aGBootLoader;
		aGBootLoader = new GBootLoader();
		aGBootLoader.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		aGBootLoader.show();
		java.awt.Insets insets = aGBootLoader.getInsets();
		aGBootLoader.setSize(aGBootLoader.getWidth() + insets.left + insets.right, aGBootLoader.getHeight() + insets.top + insets.bottom);
		aGBootLoader.setVisible(true);
	}
}
private void pushFileButton(){
	JFileChooser chooser = new JFileChooser();
	
	String[] extensions = {"geml","gpd","gad"};
	ExampleFileFilter filter = new ExampleFileFilter(extensions, "Gassan Environment File");
	chooser.addChoosableFileFilter(filter);

	File currentDir = new File(System.getProperty("user.dir"));
	chooser.setCurrentDirectory(currentDir);
	
	int ret = chooser.showOpenDialog(this);
	if(ret == JFileChooser.CANCEL_OPTION)	return;
	File selectedFile = chooser.getSelectedFile();
	getJTextField_File().setText(selectedFile.toString());
}
private void pushStartButton(){
	if( viewStarter(getJTextField_File().getText()) ){
		this.setVisible(false);
	}
	else{
		//t@CI[vłȂꍇ
		showFileErrorDialog(getJTextField_File().getText());
	}
}
private void showFileErrorDialog(String fileName) {
	Object[] msg = { rb.getString("file.error.msg1"),fileName,rb.getString("file.error.msg2") };
	JOptionPane.showMessageDialog(getContentPane(),msg,rb.getString("file.error.title"),JOptionPane.ERROR_MESSAGE)	;
}
protected static boolean viewStarter(String gemlFile){
	boolean ret = false;
	
	try{
		URL envURL = null;
		File envFile = new File( gemlFile );
		envURL = envFile.toURL();
		GElement env = App.createEnvironment(envURL);
				
		if(env != null){
			//ViewFactory
			ViewFactory viewFactory = getViewFactory(env);
			viewFactory.init(env);
			
			//model	
			GDirector director = viewFactory.getGDirector();
						
			//view
			GSMLViewer view = viewFactory.getGSMLViewer();
			GFrame aGFrame = viewFactory.getGFrame();

			//JPanel\z
			view.setMainPanel(viewFactory.getContentPane());
			
			//TextPane\z
			TextPane aTextPane = viewFactory.getTextPane();
			aTextPane.setGSMLViewer(view);
			
			//ImagePane\z
			ImagePane aImagePane = viewFactory.getImagePane();
			aImagePane.setGSMLViewer(view);
			
			//Stage -> Directorւ̊֘AZbg
			view.setDirector(director);
			
			//Director -> Stageւ̊֘AZbg
			director.setStage(view);
			
			//aGFrame
			aGFrame.init( env,viewFactory.getContentPane().getSize() );

			//controler
			GFrameController aGFrameController = viewFactory.getGFrameController();
			TextPaneController aTextPaneController = viewFactory.getTextPaneController();
			
			//event
			aGFrame.addActionListener(aGFrameController);
			aTextPane.addActionListener(aTextPaneController);
			
			//GSMLViewer -> GFrameւ̏WZbg
			view.setGFrame(aGFrame);
			//GSMLViewer -> TextPaneւ̏WZbg
			view.setTextPane(aTextPane);
			//GSMLViewer -> ImagePaneւ̏WZbg
			view.setImagePane(aImagePane);
			
			view.construct(env);

			ret = true;
		}
		else{
			ret = false;
		}
	}
	catch( java.io.IOException e ){
		ret = false;
	}
	catch( Exception e){
		ret = false;
		System.err.println(e);
	}
	
	return ret;
}
}
