package org.wffm.gsmlviewer;

/*
 * GFrame.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Image;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.URL;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.ResourceBundle;

import javax.swing.JFrame;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.WindowConstants;

import javax.swing.JPanel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JSeparator;

import org.wffm.gassan.model.GDirector;
import org.wffm.gassan.model.Bookmark;
import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * Rt[NX
  * @version 1.0.3, 2001/01/06
  * @author Yosuke Sato
  */

public class GFrame extends JFrame {
	//
	//@
	//
	//=========================================================================
	
	private GElement env = null;
	private ResourceBundle rb = null;

	private final static String resourceName = "resources/GFrame";
	private final static String softName = "Rs(Gassan)";
	private final static String version = "Version 3.1.0";
	
	public final static String defaultIconFileName = "resources/icon.gif";
	public final static String startIconFileName = "resources/new.gif";
	public final static String saveIconFileName = "resources/save.gif";
	public final static String loadIconFileName = "resources/load.gif";
	public final static String creatorIconFileName = "resources/creator.gif";
	public final static String aboutIconFileName = "resources/about.gif";
	public final static String bookmarkIconFileName = "resources/bookmark.gif";
	
	/*********** GUI\iQ ***********/
	private JPanel gContentPane = null;
	private JMenuBar gMenuBar = null;
	
	private JMenu menu_File = null;
	private JMenu menu_Load = null;
	private JMenu menu_Save = null;
	private JMenu menu_Conf = null;
	private JMenu menu_Other = null;
	
	private JMenuItem menuItem_About = null;
	private JMenuItem menuItem_Creator = null;
	private JMenuItem menuItem_Exit = null;
	private JMenuItem menuItem_StartPerform = null;
	
	private JCheckBoxMenuItem checkBoxMenuItem_AutoRun = null;
	private JCheckBoxMenuItem checkBoxMenuItem_Effect = null;
	private JCheckBoxMenuItem checkBoxMenuItem_BGM = null;
	private JCheckBoxMenuItem checkBoxMenuItem_SE = null;
	private JCheckBoxMenuItem checkBoxMenuItem_Voice = null;
	
	private ArrayList saveMenuItems = new ArrayList();
	private ArrayList loadMenuItems = new ArrayList();
	
class WindowEventHandler extends WindowAdapter {
public void windowClosing(WindowEvent e) {
	int ans = showExitDialog();
	if(ans == 0){
		dispose();
		System.exit(0);
	}
}
}
/**
 * RXgN^
 */
public GFrame() {
	super();
}
protected void addActionListener(GFrameController controller){
	getMenuItem_About().addActionListener(controller);
	getMenuItem_Creator().addActionListener(controller);
	getMenuItem_Exit().addActionListener(controller);
	getMenuItem_StartPerform().addActionListener(controller);

	getCheckBoxMenuItem_AutoRun().addActionListener(controller);
	getCheckBoxMenuItem_Effect().addActionListener(controller);
	getCheckBoxMenuItem_BGM().addActionListener(controller);
	getCheckBoxMenuItem_SE().addActionListener(controller);
	getCheckBoxMenuItem_Voice().addActionListener(controller);
}
protected JCheckBoxMenuItem getCheckBoxMenuItem_AutoRun() {
	if (checkBoxMenuItem_AutoRun == null) {
		checkBoxMenuItem_AutoRun = new JCheckBoxMenuItem();
		checkBoxMenuItem_AutoRun.setName("checkBoxMenuItem_AutoRun");
		checkBoxMenuItem_AutoRun.setText( rb.getString("checkbox.menuitem.autorun") );
	}
	return checkBoxMenuItem_AutoRun;
}
protected JCheckBoxMenuItem getCheckBoxMenuItem_BGM() {
	if (checkBoxMenuItem_BGM == null) {
		checkBoxMenuItem_BGM = new JCheckBoxMenuItem();
		checkBoxMenuItem_BGM.setName("checkBoxMenuItem_BGM");
		checkBoxMenuItem_BGM.setText( rb.getString("checkbox.menuitem.bgm") );
	}
	return checkBoxMenuItem_BGM;
}
protected JCheckBoxMenuItem getCheckBoxMenuItem_Effect() {
	if (checkBoxMenuItem_Effect == null) {
		checkBoxMenuItem_Effect = new JCheckBoxMenuItem();
		checkBoxMenuItem_Effect.setName("checkBoxMenuItem_Effect");
		checkBoxMenuItem_Effect.setText( rb.getString("checkbox.menuitem.effect") );
	}
	return checkBoxMenuItem_Effect;
}
protected JCheckBoxMenuItem getCheckBoxMenuItem_SE() {
	if (checkBoxMenuItem_SE == null) {
		checkBoxMenuItem_SE = new JCheckBoxMenuItem();
		checkBoxMenuItem_SE.setName("checkBoxMenuItem_SE");
		checkBoxMenuItem_SE.setText( rb.getString("checkbox.menuitem.se") );
	}
	return checkBoxMenuItem_SE;
}
protected JCheckBoxMenuItem getCheckBoxMenuItem_Voice() {
	if (checkBoxMenuItem_Voice == null) {
		checkBoxMenuItem_Voice = new JCheckBoxMenuItem();
		checkBoxMenuItem_Voice.setName("checkBoxMenuItem_Voice");
		checkBoxMenuItem_Voice.setText( rb.getString("checkbox.menuitem.voice") );
	}
	return checkBoxMenuItem_Voice;
}
/**
  * 擾
  * @return	
  */
public GElement getEnv(){
	return env;
}
	protected JPanel getGContentPane() {
		if (gContentPane == null) {
			gContentPane = new JPanel();
			gContentPane.setName("gContentPane");
			gContentPane.setLayout(null);
		}
		return gContentPane;
	}
protected JMenuBar getGMenuBar() {
	if (gMenuBar == null) {
		gMenuBar = new JMenuBar();
		gMenuBar.setName("gMenuBar");
		gMenuBar.add(getMenu_File());
		gMenuBar.add(getMenu_Conf());
		gMenuBar.add(getMenu_Other());
	}
	return gMenuBar;
}
protected JMenuItem[] getLoadMenuItems(){
	JMenuItem[] ret;

	ret = (JMenuItem[])loadMenuItems.toArray(new JMenuItem[loadMenuItems.size()]);
	
	return ret;
}
protected JMenu getMenu_Conf(){
	if (menu_Conf == null) {
		menu_Conf = new JMenu();
		menu_Conf.setName("menu_Conf");
		menu_Conf.setText( rb.getString("menu.conf") );

		menu_Conf.add(getCheckBoxMenuItem_AutoRun());
		menu_Conf.add(new JSeparator());
		menu_Conf.add(getCheckBoxMenuItem_Effect());
		menu_Conf.add(new JSeparator());
		menu_Conf.add(getCheckBoxMenuItem_BGM());
		menu_Conf.add(getCheckBoxMenuItem_SE());
		menu_Conf.add(getCheckBoxMenuItem_Voice());
	}
	return menu_Conf;
}
protected JMenu getMenu_File() {
	if (menu_File == null) {
		menu_File = new JMenu();
		menu_File.setName("menu_File");
		menu_File.setText( rb.getString("menu.file") );
		menu_File.add(getMenuItem_StartPerform());
		menu_File.add(getMenu_Load());
		menu_File.add(getMenu_Save());
		menu_File.add(new JSeparator());
		menu_File.add(getMenuItem_Exit());
	}
	return menu_File;
}
protected JMenu getMenu_Load() {
	if (menu_Load == null) {
		menu_Load = new JMenu();
		menu_Load.setName("menu_Load");
		menu_Load.setIcon(new ImageIcon(loadIconFileName));
		menu_Load.setText( rb.getString("menu.load") );
	}
	return menu_Load;
}
protected JMenu getMenu_Other() {
	if (menu_Other == null) {
		menu_Other = new JMenu();
		menu_Other.setName("menu_Other");
		menu_Other.setText( rb.getString("menu.other") );
		menu_Other.add(getMenuItem_Creator());
		menu_Other.add(getMenuItem_About());
	}
	return menu_Other;
}
protected JMenu getMenu_Save() {
	if (menu_Save == null) {
		menu_Save = new JMenu();
		menu_Save.setName("menu_Save");
		menu_Save.setIcon(new ImageIcon(saveIconFileName));
		menu_Save.setText( rb.getString("menu.save") );
	}
	return menu_Save;
}
protected JMenuItem getMenuItem_About() {
	if (menuItem_About == null) {
		menuItem_About = new JMenuItem();
		menuItem_About.setName("menuItem_About");
		menuItem_About.setIcon(new ImageIcon(aboutIconFileName));
		menuItem_About.setText( rb.getString("menuitem.about") );
	}
	return menuItem_About;
}
protected JMenuItem getMenuItem_Creator() {
	if (menuItem_Creator == null) {
		menuItem_Creator = new JMenuItem();
		menuItem_Creator.setName("menuItem_Creator");
		menuItem_Creator.setIcon(new ImageIcon(creatorIconFileName));
		menuItem_Creator.setText( rb.getString("menuitem.creator") );
	}
	return menuItem_Creator;
}
protected JMenuItem getMenuItem_Exit() {
	if (menuItem_Exit == null) {
		menuItem_Exit = new JMenuItem();
		menuItem_Exit.setName("menuItem_Exit");
		menuItem_Exit.setText( rb.getString("menuitem.exit") );
	}
	return menuItem_Exit;
}
protected JMenuItem getMenuItem_StartPerform(){
	if (menuItem_StartPerform == null) {
		menuItem_StartPerform = new JMenuItem();
		menuItem_StartPerform.setName("menuItem_StartPerform ");
		menuItem_StartPerform.setIcon(new ImageIcon(startIconFileName));
		menuItem_StartPerform.setText( rb.getString("menuitem.start") );
	}
	return menuItem_StartPerform;
}
protected JMenuItem[] getSaveMenuItems(){
	JMenuItem[] ret;

	ret = (JMenuItem[])saveMenuItems.toArray(new JMenuItem[saveMenuItems.size()]);
	
	return ret;
}
protected String getSoftName(){
	return softName;
}
public String getSoftTitle(){
	String ret = rb.getString("title");
	
	if(env != null){
		GElementList list = env.getChildElements();
		GElement item = null;
		
		//^Cgݒ
		list.first();
		list.search("scenario");
		item = list.item();

		GElementList list2 = null;
		GElement item2 = null;
		if(item != null){
			list2 = item.getChildElements();
			list2.first();
			list2.search("title");
			item2 = list2.item();
		}
		
		if(item2 != null){
			ret = item2.getValue();
		}
	}

	return ret;
}
protected String getVersion(){
	return version;
}
/**
  * 
  * @param	env		
  * @param	size	TCY
  */
public void init(GElement env,Dimension size){
	this.env = env;
	rb = ResourceBundle.getBundle(resourceName);
	
	if(env != null){
		GElementList list = env.getChildElements();
		GElement item = null;
		
		//^Cgݒ
		setTitle(getSoftTitle());

		list.first();
		list.search("view");
		item = list.item();
		
		//ACRݒ
		Image iconImage = null;
		if(item != null){
			String iconFile = item.getAttributeValue("iconFile");
			if(iconFile != null){
				URL source = ResourceFactory.createURL(env.getBaseURL(),iconFile);
				iconImage = ResourceFactory.createImage(source);
			}
		}
		if(iconImage == null){
			ImageIcon imageIcon = new ImageIcon(defaultIconFileName);
			iconImage = imageIcon.getImage();
		}
		setIconImage( iconImage );
		
		//TCYݒ
		setResizable(false);
		setSize((int)size.getWidth(),(int)size.getHeight()+50);
		
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE );
		addWindowListener(new WindowEventHandler());
		
		setJMenuBar(getGMenuBar());
		setContentPane(getGContentPane());

	}
}
protected void setMenuEnabled(boolean enable){
	getMenuItem_StartPerform().setEnabled(enable);
	getMenu_Save().setEnabled(enable);
	getMenu_Load().setEnabled(enable);
	/*
	getCheckBoxMenuItem_AutoRun().setEnabled(enable);
	getCheckBoxMenuItem_BGM().setEnabled(enable);
	getCheckBoxMenuItem_Effect().setEnabled(enable);
	getCheckBoxMenuItem_SE().setEnabled(enable);
	getCheckBoxMenuItem_Voice().setEnable(enable);
	*/
}
protected void showAboutDialog() {
	Object[] msg = {getSoftName(),getVersion(),"Copyright 1998-2001","щΎR(WFFM)","All Rights Reserved","http://www.wffm.org/"};
	JOptionPane.showMessageDialog(getContentPane(),msg,"About...",JOptionPane.INFORMATION_MESSAGE);
}
protected void showCreatorDialog() {

	if(env != null){
		ArrayList arrayList = new ArrayList();

		GElementList list = env.getChildElements();
		GElement item = null;
		
		list.first();
		list.search("scenario");
		item = list.item();
		
		if(item != null){
			list = item.getChildElements();
			
			list.first();
			list.search("title");
			item = list.item();
			if( item != null){
				arrayList.add( rb.getString("creator.title") + " : " + item.getValue() );
			}

			list.first();
			list.search("creator");
			item = list.item();
			if( item != null){
				arrayList.add( rb.getString("creator.name") + " : "+ item.getAttributeValue("name") );
				arrayList.add( "URL : "+ item.getAttributeValue("URL") );
				arrayList.add( "E-mail : "+ item.getAttributeValue("E-mail") );
				arrayList.add( rb.getString("creator.date") + " : "+ item.getAttributeValue("date") );
			}
		
			Object[] msg = (Object[])arrayList.toArray(new Object[arrayList.size()]);
			JOptionPane.showMessageDialog(getContentPane(),msg,rb.getString("creator.info"),JOptionPane.INFORMATION_MESSAGE);
		}
	}
}
protected int showExitDialog() {
	Object[] msg = { rb.getString("exit.msg1"),rb.getString("exit.msg2") };
	int ans = JOptionPane.showConfirmDialog(getContentPane(),msg,rb.getString("exit.title"),JOptionPane.YES_NO_OPTION)	;
	return ans;
}
protected void updateSaveLoadMenuItem(GDirector director,GFrameController controller){
	if(director != null){
		//Z[uE[hj[
		saveMenuItems = new ArrayList();
		loadMenuItems = new ArrayList();
		getMenu_Save().removeAll();
		getMenu_Load().removeAll();

		Bookmark[] bookmarks = director.getBookmarks();

		for(int i = 0; i < bookmarks.length ; i++){

			String name = null;
			String text = null;

			Bookmark bookmark = bookmarks[i];
					
			if(bookmark != null){
				Calendar date = bookmark.getCalendar();
				String am_pm;
				if(date.AM_PM == 0)	am_pm = "AM";
				else				am_pm = "PM";

				name = bookmark.getName();
				text = bookmark.getName()+"  "+
						date.get(Calendar.YEAR)+"/"+date.get(Calendar.MONTH)+"/"+date.get(Calendar.DATE)
						+" "+am_pm+date.get(Calendar.HOUR)+":"+date.get(Calendar.MINUTE)
						+":"+date.get(Calendar.SECOND);
			}
			else{
				name = "No Data";
				text = "No Data";
			}

			JMenuItem menuItem_save = new JMenuItem();
			menuItem_save.setIcon(new ImageIcon(bookmarkIconFileName));
			menuItem_save.setName(name);
			menuItem_save.setText(text);
			getMenu_Save().add(menuItem_save);
			saveMenuItems.add(menuItem_save);
			menuItem_save.addActionListener(controller);

			JMenuItem menuItem_load = new JMenuItem();
			menuItem_load.setIcon(new ImageIcon(bookmarkIconFileName));
			menuItem_load.setName(name);
			menuItem_load.setText(text);
			getMenu_Load().add(menuItem_load);
			loadMenuItems.add(menuItem_load);
			menuItem_load.addActionListener(controller);
		}
	}
}
}
