package org.wffm.gsmlviewer;

/*
 * GFrameController.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;

import org.wffm.gassan.model.GDirector;

/**
  * Rt[pRg[
  * @version 1.0.1, 2000/11/20
  * @author Yosuke Sato
  */
public class GFrameController implements ActionListener {
	//
	//@֘A
	//
	//=========================================================================
	GFrame _GFrame = null;
	GSMLViewer _GSMLViewer = null;
/**
 * RXgN^[
 * @param	_GSMLViewer	GSMLViewer
 * @param	_GFrame		GFrame
 */
public GFrameController(GSMLViewer _GSMLViewer,GFrame _GFrame) {
	this._GSMLViewer = _GSMLViewer;
	this._GFrame = _GFrame;
	if(_GSMLViewer != null && _GFrame != null){
		GDirector director = _GSMLViewer.getDirector();
		if(director != null){
			_GFrame.updateSaveLoadMenuItem(director,this);
		}
	}
}
public void actionPerformed(ActionEvent e) {
	if(_GFrame != null && _GSMLViewer != null){
		if ((e.getSource() == _GFrame.getMenuItem_About())){
			_GFrame.showAboutDialog();
		}
		else if((e.getSource() == _GFrame.getMenuItem_Creator()) ){
			_GFrame.showCreatorDialog();
		}
		else if((e.getSource() == _GFrame.getMenuItem_Exit()) ){
			int ans = _GFrame.showExitDialog();
			if(ans == 0){
				_GFrame.dispose();
				System.exit(0);
			}
		}
		else if((e.getSource() == _GFrame.getMenuItem_StartPerform())){
			GDirector director = _GSMLViewer.getDirector();
			if(director != null){
				director.startPerform();
			}
		}
		else if((e.getSource() == _GFrame.getCheckBoxMenuItem_AutoRun())){
			if(getGSMLViewer() != null && getGSMLViewer().getTextPane() != null){
				getGSMLViewer().getTextPane().setAutoRun( _GFrame.getCheckBoxMenuItem_AutoRun().getState() );
			}
		}
		else if((e.getSource() == _GFrame.getCheckBoxMenuItem_Effect())){
			if(getGSMLViewer() != null && getGSMLViewer().getImagePane() != null){
				getGSMLViewer().getImagePane().setStateEffect( _GFrame.getCheckBoxMenuItem_Effect().getState() );
			}
		}
		else if((e.getSource() == _GFrame.getCheckBoxMenuItem_BGM())){
			if(getGSMLViewer() != null){
				AudioPlayer audioPlayer = (AudioPlayer)getGSMLViewer().getAudios().get("bgm");
				audioPlayer.setState( _GFrame.getCheckBoxMenuItem_BGM().getState() );
			}
		}
		else if((e.getSource() == _GFrame.getCheckBoxMenuItem_SE())){
			if(getGSMLViewer() != null){
				AudioPlayer audioPlayer = (AudioPlayer)getGSMLViewer().getAudios().get("se");
				audioPlayer.setState( _GFrame.getCheckBoxMenuItem_SE().getState() );
			}
		}
		else if((e.getSource() == _GFrame.getCheckBoxMenuItem_Voice())){
			if(getGSMLViewer() != null){
				AudioPlayer audioPlayer = (AudioPlayer)getGSMLViewer().getAudios().get("voice");
				audioPlayer.setState( _GFrame.getCheckBoxMenuItem_Voice().getState() );
			}
		}
		
		JMenuItem[] saveMenuItems = _GFrame.getSaveMenuItems();
		for(int i = 0; i < saveMenuItems.length ; i++){
			JMenuItem menuItem = saveMenuItems[i];
			if ( e.getSource() == menuItem ){
				GDirector director = _GSMLViewer.getDirector();
				if(director != null){
					director.savePerform(i);
					_GFrame.updateSaveLoadMenuItem(director,this);
				}
			}
		}

		JMenuItem[] loadMenuItems = _GFrame.getLoadMenuItems();
		for(int i = 0; i < loadMenuItems.length ; i++){
			JMenuItem menuItem = loadMenuItems[i];
			if ( e.getSource() == menuItem){
				GDirector director = _GSMLViewer.getDirector();
				if(director != null){
					if( !(menuItem.getName().equals("No Data")) ){
						director.startPerform(i);
					}
				}
			}
		}
	}	
}
/**
  * GFrame擾
  * @return	GFrame
  */
public GFrame getGFrame(){
	return _GFrame;
}
/**
  * GSMLViewer擾
  * @return	GSMLViewer
  */
public GSMLViewer getGSMLViewer(){
	return _GSMLViewer;
}
}
