package org.wffm.gsmlviewer;

/*
 * GSMLViewer.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.Hashtable;
import java.util.Enumeration;

import javax.swing.JPanel;
import javax.swing.ImageIcon;
import javax.swing.Timer;

import org.wffm.gassan.model.GDirector;
import org.wffm.gassan.model.GStage;
import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;
import org.wffm.gassan.view.plugin.GPlugin;

import org.wffm.gsmlviewer.pane.TextPane;
import org.wffm.gsmlviewer.pane.ImagePane;

/**
  * GStageView
  * @version 1.1.3, 2001/03/01
  * @author Yosuke Sato
  */
public class GSMLViewer implements GStage {
	//
	//  ֘A
	//
	//=========================================================================
	private GDirector _director = null;
	private GElement _scene = null;
	private GElement _env = null;
	
	//
	//  W
	//
	//=========================================================================
	private GFrame _GFrame = null;
	private TextPane _TextPane = null;
	private ImagePane _ImagePane = null;
	private Hashtable _audios = null;

	//
	//  
	//
	//=========================================================================
	private JPanel mainPanel = null;
	
	//
	//  [Jϐ
	//
	//=========================================================================
	private GElementList cursor_scene = null; 	//V[ԕێ
	private GElementList cursor_cut = null;		//Jbgԕێ
	
	private int state = 0;						//s

	public final static int NONE = 0;
	public final static int TEXT = 1;
	public final static int SELECTION = 2;
	public final static int IMAGELIST = 3;
	public final static int AUDIO = 4;
	public final static int OPENING = 5;
	public final static int ENDING = 6;
	public final static int PLUGIN = 7;
	public final static int TIMER = 8;
	
	private JPanel cardPanel = null;
	private CardLayout cardLayout = null;
	private TimerEventHandler timerEventHandler = new TimerEventHandler();
	
	private final String defaultStartImageFileName = "resources/start.gif";
class TimerEventHandler implements ActionListener {
	public void actionPerformed(ActionEvent e) {
		GSMLViewer.this.reaction();
	}
}
/**
 * RXgN^
 */
public GSMLViewer() {
	//I[fBIW𐶐
	_audios = new Hashtable();

	_audios.put("bgm",AudioPlayer.create());
	_audios.put("se",AudioPlayer.create());
	_audios.put("voice",AudioPlayer.create());

	//J[hpl̐ݒ
	cardPanel = new JPanel();
	cardPanel.setName("CardPanel");
	cardLayout = new CardLayout();
	cardPanel.setLayout(cardLayout);
}
/**
  * ݉c
  * @param	env	
  */
public void construct(GElement _env) {

	this._env = _env;
	
	if(getGFrame() != null && getImagePane () != null && getTextPane() != null){
		GPlugin opening = getOpening();
		
		//J[hCAEg̐ݒ
		getGFrame().getContentPane().setLayout(new BorderLayout());
		getGFrame().getContentPane().add("Center",cardPanel);

		//I[vjOzu
		if(opening != null){
			cardPanel.add("Opening",opening);
		}

		//I[vjOC[W
		getImagePane().setDrawImage( getStartImage() );
			
		//Cplzu
		cardPanel.add("MainPanel",getMainPanel());

		//ݒ`FbN{bNX
		getGFrame().getCheckBoxMenuItem_AutoRun().setState( getTextPane().getAutoRun() );
		
		getGFrame().getCheckBoxMenuItem_Effect().setState( getImagePane().getStateEffect() );
				
		AudioPlayer audioPlayer = (AudioPlayer)_audios.get("bgm");
		getGFrame().getCheckBoxMenuItem_BGM().setState( audioPlayer.getState() );
		audioPlayer = (AudioPlayer)_audios.get("se");
		getGFrame().getCheckBoxMenuItem_SE().setState( audioPlayer.getState() );
		audioPlayer = (AudioPlayer)_audios.get("voice");
		getGFrame().getCheckBoxMenuItem_Voice().setState( audioPlayer.getState() );
		
		//WindowI[v
		getGFrame().setVisible(true);

		//I[vjOs
		try{
			//I[vjOs
			opening.init();
			
			state = OPENING;
			
			//ej[gps
			getGFrame().setMenuEnabled(false);
		}catch(Exception e){
			state = NONE;

			if(getStartAudioFile() != null){
				audioPlayer = (AudioPlayer)_audios.get("bgm");
				URL source = ResourceFactory.createURL(_env.getBaseURL(),getStartAudioFile());
				audioPlayer.setAudio( source );
				audioPlayer.setLoop(true);
				audioPlayer.play();
			}
			
			cardLayout.show(cardPanel,"MainPanel");
		}
		/*
		if(opening != null){
			state = OPENING;
			
			//ej[gps
			getGFrame().setMenuEnabled(false);
			
			//I[vjOs
			opening.init();
		}
		else{
			state = NONE;
		
			audioPlayer = (AudioPlayer)_audios.get("bgm");
			URL source = ResourceFactory.createURL(_env.getBaseURL(),getStartAudioFile());
			audioPlayer.setAudio( source );
			audioPlayer.setLoop(true);
			audioPlayer.play();
			cardLayout.show(cardPanel,"MainPanel");
		}
		*/
	}
	else{
		System.err.println("Can not init GSMLViewer.");
	}	
	/* --- eXgp
	//GFrameփplZbg
	getGFrame().getContentPane().setLayout(new java.awt.BorderLayout());
	getGFrame().getContentPane().add("Center",aImagePane);
		
	getImagePane().setLayout(null);
	getImagePane().add(aTextPane);
	*/
}
/**
  * Audios擾
  * @return	Audios
  */
public Hashtable getAudios(){
	return _audios;
}
protected GElementList getCursorCut(){
	return cursor_cut;
}
protected GElementList getCursorScene(){
	return cursor_scene;
}
/**
  * o҂擾
  * @return	o
  */
public GDirector getDirector() {
	return _director;
}
private GPlugin getEnding(){
	GPlugin ret = null;

	GElementList list = getEnv().getChildElements();
	GElement view = null;
	
	list.first();
	list.search("view");
	view = list.item();
	
	if(view != null){
		GElementList list1 = view.getChildElements();
		GElement opening = null;

		list1.first();
		list1.search("ending");
		opening = list1.item();
		
		if(opening != null){
			//GfBO
			ret = GPlugin.create( opening.getAttributeValue("name") );

			if(ret != null){
				//GfBO
				ret.setSize( getMainPanel().getSize() );
				ret.setStage(this);
				ret.setParam( GEMLUtility.getParam(opening) );
			}
			else{
				System.err.println("Can not create opening : " + opening.getAttributeValue("name") );
			}
		}
	}

	return ret;
}
/**
  * 擾
  * @return	
  */
public GElement getEnv(){
	return _env;
}
/**
  * GFrame擾
  * @return	GFrame
  */
public GFrame getGFrame(){
	return _GFrame;
}
private GPlugin getGPlugin(GElement plugin){
	GPlugin ret = null;

	//vOC
	ret = GPlugin.create( plugin.getAttributeValue("name") );

	if(ret != null){
		//vOC
		ret.setSize( getMainPanel().getSize() );
		ret.setStage(this);
		ret.setParam( GEMLUtility.getParam(plugin) );
	}

	return ret;
}
/**
  * ImagePane擾
  * @return	ImagePane
  */
public ImagePane getImagePane(){
	return _ImagePane;
}
public JPanel getMainPanel(){
	return mainPanel;
}
private GPlugin getOpening(){
	GPlugin ret = null;

	GElementList list = getEnv().getChildElements();
	GElement view = null;
	
	list.first();
	list.search("view");
	view = list.item();
	
	if(view != null){
		GElementList list1 = view.getChildElements();
		GElement opening = null;

		list1.first();
		list1.search("opening");
		opening = list1.item();
		
		if(opening != null){
			//I[vjO
			ret = GPlugin.create( opening.getAttributeValue("name") );

			if(ret != null){
				//I[vjO
				ret.setSize( getMainPanel().getSize() );
				ret.setStage(this);
				ret.setParam( GEMLUtility.getParam(opening) );
			}
			else{
				System.err.println("Can not create opening : " + opening.getAttributeValue("name") );
			}
		}
	}

	return ret;
}
/**
  * V[擾
  * @return	V[
  */
public GElement getScene() {
	return _scene;
}
private String getStartAudioFile(){
	String ret = null;
	
	if(getEnv() != null){
		GElementList list = getEnv().getChildElements();
		GElement item = null;
	
		list.first();
		list.search("view");
		item = list.item();

		if(item != null){
			ret = item.getAttributeValue("audioFile");
		}
	}

	return ret;
}
private Image getStartImage(){
	Image ret = null;

	String imageFile = null;
	
	if(getEnv() != null){
		GElementList list = getEnv().getChildElements();
		GElement item = null;
	
		list.first();
		list.search("view");
		item = list.item();

		if(item != null){
			imageFile = item.getAttributeValue("imageFile");
		}
	}
	
	if(imageFile == null){
		ImageIcon imageIcon = new ImageIcon(defaultStartImageFileName);
		ret = imageIcon.getImage();
	}
	else{
		URL source = ResourceFactory.createURL(_env.getBaseURL(),imageFile);
		ret = ResourceFactory.createImage(source);				
	}

	return ret;
}
public int getState(){
	return state;
}
/**
  * TextPane擾
  * @return	TextPane
  */
public TextPane getTextPane(){
	return _TextPane;
}
protected void initPane(){
	getTextPane().stop();
	timer(100);					//TextPanestop҂^C}[
	getTextPane().clear();
	getImagePane().filterOut();
}
/**
  * w
  * @param	_scene	V[
  */
public void instruct(GElement _scene) {
	this._scene = _scene;
	this.cursor_scene = null;

	//TextPane & ImagePane 
	initPane();
			
	if(_scene != null){
		if(getGFrame() != null){
			getGFrame().setTitle(getGFrame().getSoftTitle() + " - " + _scene.getAttributeValue("name") + " - " );
		}
		cursor_scene = _scene.getChildElements();
		cursor_scene.first();
		
		operateScene();
	}
	else{
		GPlugin ending = getEnding();

		//I[fBI~
		Enumeration enum = _audios.elements();
		while(enum.hasMoreElements()){
			AudioPlayer audioPlayer = (AudioPlayer)enum.nextElement();
			audioPlayer.stop();
		}

		try{
			//GfBOs
			ending.init();
						
			cardPanel.add("Ending",ending);
			cardLayout.show(cardPanel,"Ending");
			
			state = ENDING;
			
			//ej[gps
			getGFrame().setMenuEnabled(false);
			
		}catch(Exception e){
			state = NONE;
				
			//I[vjOC[W
			getImagePane().setDrawImage( getStartImage() );

			if(getStartAudioFile() != null){
				AudioPlayer audioPlayer = (AudioPlayer)_audios.get("bgm");
				URL source = ResourceFactory.createURL(_env.getBaseURL(),getStartAudioFile());
				audioPlayer.setAudio( source );
				audioPlayer.setLoop(true);
				audioPlayer.play();
			}
			
			cardLayout.show(cardPanel,"MainPanel");
			
			//ԊǗ
		}
		/*
		if(ending != null){
			cardPanel.add("Ending",ending);

			state = ENDING;
			
			//ej[gps
			getGFrame().setMenuEnabled(false);
			
			//GfBOs
			cardLayout.show(cardPanel,"Ending");
			ending.init();
		}
		else{
			state = NONE;
				
			//I[vjOC[W
			getImagePane().setDrawImage( getStartImage() );
		
			AudioPlayer audioPlayer = (AudioPlayer)_audios.get("bgm");
			URL source = ResourceFactory.createURL(_env.getBaseURL(),getStartAudioFile());
			audioPlayer.setAudio( source );
			audioPlayer.setLoop(true);
			audioPlayer.play();
			
			cardLayout.show(cardPanel,"MainPanel");
			
			//ԊǗ
		}
		*/
	}
}
private void operateAudio(GElement audio){
	String layer = audio.getAttributeValue("layer");
	String file = audio.getAttributeValue("file");
	String command = audio.getAttributeValue("command");
	
	if(layer != null && file != null && command != null){
		try{
			AudioPlayer audioPlayer = (AudioPlayer)_audios.get(layer);
			
			if(command.equals("stop")){
				audioPlayer.clear();
			}
			else if(command.equals("loop")){
				URL source = ResourceFactory.createURL(audio.getBaseURL(),file);
				
				if(!audioPlayer.isSource(source) || !audioPlayer.getLoop()){
					audioPlayer.setAudio(source);
					audioPlayer.setLoop(true);
					audioPlayer.play();
				}
			}
			else if(command.equals("play")){
				URL source = ResourceFactory.createURL(audio.getBaseURL(),file);
				if(!audioPlayer.isSource(source) || audioPlayer.getLoop()){
					audioPlayer.setAudio(source);
					audioPlayer.setLoop(false);
					audioPlayer.play();
				}
			}
		}
		catch(Exception e){
			System.err.println("Audio Error...");
		}
	}
}
protected void operateCut(){
	if(cursor_cut != null){
		for(GElement element = cursor_cut.item(); element != null; cursor_cut.next(),element = cursor_cut.item()){
			if( element.getName().equals("text") ){
				state = TEXT;
				operateText(element);
				cursor_cut.next();
				return;
			}
			else if( element.getName().equals("selection") ){
				state = SELECTION;
				operateSelection(element);
				cursor_cut.next();
				return;
			}
			else if( element.getName().equals("audio") ){
				state = AUDIO;
				operateAudio(element);
				state = NONE;
			}
			else if( element.getName().equals("imagelist") ){
				state = IMAGELIST;
				operateImagelist(element);
				cursor_cut.next();
				return;
			}
			else if( element.getName().equals("plugin") ){
				if(operatePlugin(element)){
					state = PLUGIN;
					cursor_cut.next();
					return;
				}
			}
			else if( element.getName().equals("timer") ){
				state = TIMER;
				operateTimer(element);
				cursor_cut.next();
				return;
			}
			else{
				operateOtherCut(element);
			}
		}
	}
	cursor_scene.next();
	operateScene();
}
private void operateImagelist(GElement imagelist){
	initPane();
	getImagePane().setImagelist( imagelist );
}
protected void operateOtherCut(GElement other){
	//̑̃T|[gĂȂ^Ȍ
	System.err.println("Non support in <cut>: <" + other.getName() + ">");
}
protected void operateOtherScene(GElement other){
	//̑̃T|[gĂȂ^Ȍ
	System.err.println("Non support in <scene>: <" + other.getName() + ">");
}
private boolean operatePlugin(GElement plugin){
	boolean ret = false; // true: false:s

	GPlugin aGPlugin = getGPlugin(plugin);

	if(aGPlugin != null && getGFrame() != null){
		cardPanel.add("GPlugin",aGPlugin);
		
		try{
			//I[fBIꎞ~
			Enumeration e = _audios.elements();
			while(e.hasMoreElements()){
				AudioPlayer audioPlayer = (AudioPlayer)e.nextElement();
				audioPlayer.stop();
			}
		
			//ej[gps
			getGFrame().setMenuEnabled(false);
		
			initPane();
			
			//vOCs
			aGPlugin.setBackImage(getImagePane().getDrawImage());
			aGPlugin.init();
			cardLayout.show(cardPanel,"GPlugin");
				
			ret = true;
		}
		catch(Exception e){
			ret = false;
		}
	}
	return ret;
}
protected void operateScene(){
	if(cursor_scene != null){
		for(GElement element = cursor_scene.item(); element != null; cursor_scene.next(),element = cursor_scene.item()){
			if( element.getName().equals("cut") ){
				//JbgJ[\
				cursor_cut = element.getChildElements();
				cursor_cut.first();
				
				operateCut();
				return;
			}
			else{
				operateOtherScene(element);
			}
		}
	}
	if(getDirector() != null){
		state = NONE;
		getDirector().notifySceneEnd();
	}
}
private void operateSelection(GElement selection){
	if(getTextPane() != null){
		getImagePane().filterIn();
		getTextPane().setSelection(selection);
	}
}
private void operateText(GElement text){
	if(getTextPane() != null){
		getImagePane().filterIn();
		getTextPane().setText(text);
	}
}
private void operateTimer(GElement timer){
	String value = timer.getAttributeValue("value");
	int msec = 10;
	if(value != null){
		try{
			msec = Integer.parseInt(value);
		}catch(NumberFormatException e){
			System.err.println("Timer Error...");
			msec = 10;
		}
	}
	Timer aTimer = new Timer(msec,timerEventHandler);
	aTimer.setRepeats(false);
	aTimer.start();
}
private void playStartAudio(){
	if(getStartAudioFile() != null){
		AudioPlayer audioPlayer = (AudioPlayer)_audios.get("bgm");
		URL source = ResourceFactory.createURL(_env.getBaseURL(),getStartAudioFile());
		audioPlayer.setAudio(source);
		audioPlayer.setLoop(true);
		audioPlayer.play();
	}
}
/**
  * 
  */
public void reaction() {
	if(state == IMAGELIST){
		state = NONE;
		operateCut();
	}
	else if(state == TEXT){
		if(getTextPane() != null){
			getTextPane().stop();
		}
		state = NONE;
		operateCut();
	}
	else if(state == SELECTION){
		if(getTextPane() != null){
			getTextPane().stop();
			getTextPane().clear();
		}
		state = NONE;
		operateCut();
	}
	else if(state == OPENING){
		//ej[gp\
		getGFrame().setMenuEnabled(true);
		playStartAudio();
		cardLayout.show(cardPanel,"MainPanel");

		state = NONE;
	}
	else if(state == PLUGIN){
		//ej[gp\
		getGFrame().setMenuEnabled(true);
		
		//[vԂ̃I[fBIĊJ
		Enumeration e = _audios.elements();
		while(e.hasMoreElements()){
			AudioPlayer audioPlayer = (AudioPlayer)e.nextElement();
			if(audioPlayer.getLoop()){
				audioPlayer.play();
			}
		}
		
		cardLayout.show(cardPanel,"MainPanel");
		
		state = NONE;
		operateCut();
	}
	else if(state == ENDING){
		//ej[gp\
		getGFrame().setMenuEnabled(true);
		//I[vjOC[W
		getImagePane().setDrawImage( getStartImage() );
		playStartAudio();
		cardLayout.show(cardPanel,"MainPanel");
		state = NONE;
	}
	else if(state == TIMER){
		state = NONE;
		operateCut();
	}
}
protected void setCursorCut(GElementList cursor_cut){
	this.cursor_cut = cursor_cut;
}
/**
  * o҂ݒ
  * @param	_director	o
  */
public void setDirector(GDirector _director) {
	this._director = _director;
}
/**
  * GFrameւ̏Wݒ
  * @param	_GFrame	GFrame
  */
public void setGFrame(GFrame _GFrame){
	this._GFrame = _GFrame;
}
/**
  * ImagePaneւ̏Wݒ
  * @param	_ImagePane	ImagePane
  */
public void setImagePane(ImagePane _ImagePane){
	this._ImagePane = _ImagePane;
}
public void setMainPanel(JPanel mainPanel){
	this.mainPanel = mainPanel;
}
protected void setState(int state){
	this.state = state;
}
/**
  * TextPaneւ̏Wݒ
  * @param	_TextPane	TextPane
  */
public void setTextPane(TextPane _TextPane){
	this._TextPane = _TextPane;
}
protected void timer(int i) {
	try{
		Thread.sleep(i);
	}catch(InterruptedException e){}
}
}
