package org.wffm.gsmlviewer.filter;

/*
 * FullTextFilter.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.image.LookupOp;
import java.awt.image.ByteLookupTable;
import javax.swing.JComponent;

import org.wffm.gassan.view.effect.ExchangeEffect;

/**
  * SʃeLXgptB^[NX
  * @version 1.0.0, 2000/12/26
  * @author Yosuke Sato
  */
public class FullTextFilter extends ImagePaneFilter {
	//
	//  [Jϐ
	//
	//=========================================================================
	private BufferedImage chacheImage = null;
	
	public static final int timer = 25;   					//wi{
/**
 * FullTextFilter RXgN^[ERgB
 */
public FullTextFilter() {
	super();
}
private void fadeRun(boolean fadeMode,BufferedImage image){
	//fadeMode : true 邭 false Â
	if(image != null){
	    //tB^[̉
		int filter = 5;
		BufferedImage bimg = new BufferedImage(image.getWidth(),image.getHeight(),BufferedImage.TYPE_INT_RGB);
		byte b[] = new byte[256];
		
		int k = 255;
		if(fadeMode)	k = 155;
		else			k = 255;
		
		for(int j = 0; j < filter ;j++){
			for(int i=0;i<256;i++) b[i]=(byte)(i*k/256.0);
			ByteLookupTable blt = new ByteLookupTable(0,b);
			LookupOp lo = new LookupOp(blt,null);
			lo.filter(image,bimg);
			
			Graphics g = getImagePane().getGraphics();
			g.drawImage(bimg,0,0,getImagePane());
			timer(timer*4);
			if(fadeMode)	k = k+25;
		    else			k = k-25;
		}
		getImagePane().setDrawImage(bimg);
	}
}
/**
 * filterIN \bhERgB
 */
protected void filter_in() {
	chacheImage = createBufferedImage(getImagePane().getDrawImage());
	fadeRun(false,chacheImage);
}
/**
 * filterOUT \bhERgB
 */
protected void filter_out() {
	fadeRun(true,chacheImage);
}
protected void timer(int i) {
	try{
		Thread.sleep(i);
	}catch(InterruptedException e){}
}
}
