package org.wffm.gsmlviewer.pane;

/*
 * TextPane.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionListener;
import java.awt.Graphics2D;
import java.awt.Font;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.util.Vector;
import java.util.Hashtable;
import java.text.BreakIterator;

import javax.swing.JComponent;
import javax.swing.BoxLayout;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

import org.wffm.gsmlviewer.GSMLViewer;
import org.wffm.gsmlviewer.GEMLUtility;

/**
  * TextLabelNX
  * @version 1.1.5, 2001/01/30
  * @author Yosuke Sato
  */
public class TextPane extends JComponent implements Runnable {
	//
	//@֘A
	//
	//=========================================================================
	private GSMLViewer _GSMLViewer = null;
	
	//
	//@W
	//
	//=========================================================================
	private Vector labels = new Vector();

	//
	//@
	//
	//=========================================================================
	private Dimension defaultSize = null;
	private int fontSize = 10;
	
	private int state = 0;
	public final static int NORMAL = 0;
	public final static int OPERATE = 1;			//`撆
	public final static int LINE_WAIT = 2;			//Iҋ@
	public final static int PAGECHANGE_WAIT = 3;	//y[W؂ւҋ@
	public final static int SELECTION_WAIT = 4;		//Iҋ@

	//
	//  [Jϐ
	//
	//=========================================================================
	private Vector line = new Vector();				//ő啶ŕꂽeLXg̏Wi[
	private Hashtable operations = new Hashtable();
	private volatile Thread kick = null;
	private int paintedLabelCounter = 0;			//\Ă郉xԍ̃J[\
	private boolean mousePush = false;				//}EXtrueAȊOfalse
	private boolean autoRun = false;				//̑I܂Ŏs̏ꍇtrue,ȊOfalse
	private boolean prompt = true;					//NbNwL̏ꍇtrue,ȊOfalse

	public static final int paintWait = 15;			//̕\Xs[h
	public static final int timerWait = 200;		//ҋ@\Xs[h
	public static final int scrollWait = 500;		//NA[ҋ@
/**
 * \bh̋Lq}ĂB
 * 쐬 : (01/01/21 16:48:33)
 */
public TextPane() {
	super();
}
public void addActionListener(ActionListener aActionListener){
	for(int i = 0;i < getLabels().size(); i++){
		TextLabel label = (TextLabel)getLabels().elementAt(i);
		label.addActionListener(aActionListener);
	}
}
/**
  * \ĂeLXgSď
  */
public synchronized void clear() {
	//JE^[Zbg
	paintedLabelCounter = 0;
	//eLXg
	for(int i = 0; i < labels.size(); i++){
		TextLabel label = (TextLabel)labels.elementAt(i);
		label.setText(" ");
		label.setFocusPainted(false);
	}
}
/**
  * sԂ擾
  * ̑I܂Ŏs̏ꍇtrue,ȊOfalse
  * @return	s
  */
public boolean getAutoRun(){
	return autoRun;
}
/**
  * ftHg̃TCY擾
  * @return	ftHgTCY
  */
public Dimension getDefaultSize(){
	return defaultSize;
}
public int getFontSize(){
	return fontSize;
}
/**
  * GSMLViewer擾
  * @return	GSMLVIewer
  */
public GSMLViewer getGSMLViewer(){
	return _GSMLViewer;
}
/**
  * TextLabelւ̏W擾
  * @return	TextLabelւ̏W
  */
public Vector getLabels(){
	return labels;
}
protected Vector getLine(){
	return line;
}
private int getLineCount(){
	//y[W̍ősvZ
	int height = (int)getDefaultSize().getHeight();
	return height / (getFontSize()+5);
}
private int getLineWidth(){
	//s̕擾
	int width = (int)getDefaultSize().getWidth();
	return width;
}
protected Hashtable getOperations(){
	return operations;
}
protected int getPaintedLabelCounter(){
	return paintedLabelCounter;
}
/**
  * Ԃ擾
  * @return	
  */
public int getState(){
	return state;
}
/**
  * ۂɕ`悳ۂ̃tHg̕擾
  * @param text	`悷\̃eLXg
  * @return	ۂɕ`悳ۂ̃tHg̕
  */
public int getStringWidth(String text,int fontSize){
	int ret = -1;
	
	Graphics2D g2 = (Graphics2D)getGraphics();
	if(g2 != null){
		FontRenderContext frc = g2.getFontRenderContext();
		
		Font f = new Font("sansserif",Font.BOLD,fontSize);
		TextLayout tl = new TextLayout(text,f,frc);
		ret = (int)tl.getVisibleAdvance();
	}

	return ret;
}
/**
  * 
  */
public void init(Dimension size,int fontSize){
	this.defaultSize = size;
	setFontSize(fontSize);
	super.setSize(defaultSize);

	//TextLabelzu
	setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
	
	for(int i = 0;i < getLineCount(); i++){
		TextLabel label = new TextLabel();
		label.setSize((int)getDefaultSize().getWidth(),getFontSize()+5);
		label.setFontSize(getFontSize());
		add(label);
		getLabels().addElement(label);
	}
}
public void run() {
	state = OPERATE;
	String text = null;
	TextLabel label = null;
	Thread thisThread = Thread.currentThread();
	
	for(int i = 0; i < line.size(); i++){
		if(kick != thisThread){
			return;
		}
		
		text = (String)line.elementAt(i);
		if( !(paintedLabelCounter < labels.size()) ){
			clear();
		}
		label = (TextLabel)labels.elementAt(paintedLabelCounter);
		label.setFocusPainted(false);
			
		//WaitȂP`
		for(int charCounter = 0; charCounter <= text.length();charCounter++){
			String message = text.substring(0,charCounter);
			label.setText(message);
			timer(paintWait);
		}
		
		paintedLabelCounter++;
		
		if( !(paintedLabelCounter < labels.size()) ){
			if( !(i + 1 < line.size()) ){
				//ŏIs
				break;
			}
			else{
				//y[W
				state = PAGECHANGE_WAIT;
				textWaiter(label,text);
				state = TextPane.OPERATE;
			}
		}
	}
	if(kick != thisThread){
		return;
	}
	
	if(prompt){
		//\Ivvg\
		state = LINE_WAIT;
		textWaiter(label,text);
		state = NORMAL;
	}
	
	if(kick != thisThread){
		return;
	}
	
	//Iʒm
	if(getGSMLViewer() != null){
		prompt = true;
		getGSMLViewer().reaction();
	}
}
/**
  * sԂݒ
  * ̑I܂Ŏs̏ꍇtrue,ȊOfalse
  * @param	autoRun s
  */
public synchronized void setAutoRun(boolean autoRun){
	this.autoRun = autoRun;
}
public void setFontSize(int fontSize){
	this.fontSize = fontSize;
}
/**
  * GSMLViewerݒ
  * @param	_GSMLViewer	GSMLViewer
  */
public void setGSMLViewer(GSMLViewer _GSMLViewer){
	this._GSMLViewer = _GSMLViewer;
}
protected synchronized void setMousePush(boolean mousePush){
	this.mousePush = mousePush;
}
/**
  * Iݒ
  * @param	selection	I
  */
public synchronized void setSelection(GElement selection){

	if(state == NORMAL){
		operations = new Hashtable();
		Vector alternatives = new Vector();
	
		if(selection.hasChildElements()){
			GElementList list = selection.getChildElements();
			list.first();
			
			
			for(GElement element = list.item(); element != null; list.next(),element = list.item()){
				if(element.getName().equals("alternative")){
					alternatives.add(element.getValue());
					operations.put(element.getValue(),element.getAttributeValue("operation"));
				}
			}
		}

		//si߂
		paintedLabelCounter++;

		//IʂɎ܂ȂꍇCy[WsD
		int length = paintedLabelCounter + alternatives.size();
		if( length >= labels.size() ){
			clear();
		}

		for(int i = 0; i < alternatives.size() ;i++){
			//ʓɑI܂ȂꍇC܂ȂI͔j
			if(paintedLabelCounter >= labels.size()){
				System.out.println("can not draw selection : [ " + (String)alternatives.elementAt(i) + " ]");
				break;
			}
			TextLabel label = (TextLabel)labels.elementAt(paintedLabelCounter);
			label.setText( (String)alternatives.elementAt(i) );
			label.setFocusPainted(true);
			paintedLabelCounter++;
		}

		state = SELECTION_WAIT;
	}
}
protected synchronized void setState(int state){
	this.state = state;
}
/**
  * ͂ݒ
  * @param	text	
  */
public synchronized void setText(GElement text){
	if(state == NORMAL){
		String scrollValue = text.getAttributeValue("scroll");
		if(scrollValue != null && scrollValue.equals("on")){
			clear();
			timer(scrollWait);
		}
		String clickValue = text.getAttributeValue("prompt");
		if(clickValue != null && clickValue.equals("off")){
			prompt = false;
		}
		line = textCutter( text.getValue() );
		start();
	}
}
private void start() {
	kick = new Thread(this);
	kick.start();
}
/**
  * XbhSɒ~
  */
public void stop() {
	/*
	if(state == LINE_WAIT || state == PAGECHANGE_WAIT){
		//eLXgEFCgĂꍇXbhI
		if(kick != null){
			kick.stop();
		}
	}
	*/
	
	kick = null;
	setState(TextPane.NORMAL);
	
	/* version 1.0.3ȑÕR[h
	kick = null;
	
	if(textWait){
		mousePush = true;
		while(true){
			if(!textWait)	break;
		}
	}
	*/
}
protected Vector textCutter(String text){
	Vector ret = new Vector();

	if(text != null && text.length() != 0){
		int lineWidth = getLineWidth() - (getStringWidth("",getFontSize()));
		
		BreakIterator boundary = BreakIterator.getCharacterInstance();
		boundary.setText(text);
		int start = boundary.first();
		int end = boundary.next();
		
		for(; end != BreakIterator.DONE; end = boundary.next()){
			if( getStringWidth(text.substring(start,end),getFontSize()) > lineWidth){
				end = boundary.previous();
				ret.addElement(text.substring(start,end));
				start = end;
				end = boundary.next();
			}
		}
			
		end = boundary.last();
		if(start != end){
			ret.addElement(text.substring(start,end));
		}
	}
		
	return ret;
}
private void textWaiter(TextLabel label,String text) {
	Thread thisThread = Thread.currentThread();
	
	if(label != null && text != null){
		String message = "";
		if(state == LINE_WAIT)				message = "";
		else if(state == PAGECHANGE_WAIT)	message = "";
	
		for(int i = 0;!mousePush;i++){
			label.setText(text + message);
			timer(timerWait);
			label.setText(text + "@");
			timer(timerWait);
			
			//s̏
			if(i > 2 && getAutoRun()){
				setMousePush(true);
			}
			
			if(kick != thisThread){
				return;
			}	
		}
		
		mousePush = false;
	}
	
}
private void timer(int i) {
	try{
		Thread.sleep(i);
	}catch(InterruptedException e){}
}
}
